/*-----------------------------------------------------------------------
 * File: ALLOCNOD.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "ber_der.h"
#include "ber_internal.h"

/* 
 * allocate space for a DER_node with N children
 */
DER_NODE_PTR 
DER_AllocateNode(BER_HANDLE AppHandle,
                 BER_MEMORY_FUNCS_PTR MemoryFunctions,
                 sint32 NumberOfChildren)
{
    DER_NODE_PTR result;
    result = 
    (DER_NODE_PTR) BERDER_MALLOC_WRAPPER(MemoryFunctions->malloc_func, AppHandle, sizeof(struct der_node_child_struct) * NumberOfChildren + 
        sizeof(DER_NODE));
    cssm_memset(result, 0, sizeof(DER_NODE));
    result->Count = NumberOfChildren;   /* we just wiped it out--store again */
    result->Child = 
    (struct der_node_child_struct *) (((uint8 *) result) +
        sizeof(DER_NODE));

    return result;
}
