/*-----------------------------------------------------------------------
 * File: B2UNLONG.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "ber_der.h"

/* decode a small BER integer to a C unsigned long value */
uint32 
BER_BerToUnlong(const uint8 *Octets)
{
    sint32 length, noctets;
    uint32 value;

    /* bypass tag, assume integer with primitive definite length */
    if ((*Octets++ & 31) == 31) { /* long tag */
        while ((*Octets++ & 128) != 0);
    }
    /* compute length of contents */
    noctets = *Octets & 127;
    if ((*Octets++ & 128) != 0) { 
        length = 0;          /* long definite */
        while (noctets-- > 0) length = 256 * length + *Octets++;
    } else length = noctets; /* short definite */
    /* get value */
    value = 0;
    while (length-- > 0) value = value * 256 + *Octets++;

    return value;
}
