/*-----------------------------------------------------------------------
 * File: OUTLEN.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "ber_der.h"

/* 
 * output length for BER/DER 
 */
uint32 
BER_OutputLength(       /* return number of bytes it took to store the length */
    uint32 Value,       /* length as binary integer */
    uint8 *Octets)      /* output buffer */
{
    uint32 temp, length;
    sint16 len;

    temp = 1;
    for (len = 0; len < sizeof(uint32); len++) {
        if (Value < temp) break;
        temp = temp * 256;
    }
    if (Value > 127) {   /* long form */
        length = len + 1;
        *Octets++ = (uint8) (128 + len);
        while (len > 0) {
            Octets[--len] = (uint8) (Value % 256);
            Value = Value / 256;
        }
    } else {    /* short form */
        *Octets++ = (uint8) Value;
        length = 1;
    }

    return length;
}
