/*-----------------------------------------------------------------------
 * File: TAG_COMP.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "ber_der.h"

/* routine to compare BER tag values */
sint32 
BER_TagCompare(const uint8 *A, const uint8 *B)
{
    if (*A != *B) return *A - *B;
    if ((*A & 31) != 31) return 0;  /* short tag */
    for (;;) {
        if (*++A != *++B) return *A - *B;
        if ((*A & 128) == 0) break;
    }
    return 0;   /* long equal tags */
}
