/*-----------------------------------------------------------------------
 * File: CLDERLL.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

#ifndef _CLDERLL_H
#define _CLDERLL_H    

#include "ber_der.h"
#include "clutil.h"


/* List management functions */
CSSM_RETURN cl_der_GetLeafNode( CSSM_CLUTIL_CONTEXT *pContext,
                               CL_DER_NODE_HANDLE Handle,
                               BER_PARSED_ITEM_PTR *result_val);

CSSM_RETURN cl_der_GetParentNode(CSSM_CLUTIL_CONTEXT *pContext,
                                CL_DER_NODE_HANDLE Handle,
                                DER_NODE_PTR *result_val);

CSSM_RETURN cl_der_AddLeafNode( CSSM_CLUTIL_CONTEXT *pContext,
                               BER_PARSED_ITEM_PTR NodePtr,
                               CL_DER_NODE_HANDLE *results_handle);

CSSM_RETURN  cl_der_AddParentNode( CSSM_CLUTIL_CONTEXT *pContext,
                                  DER_NODE_PTR NodePtr,
                                  CL_DER_NODE_HANDLE *result_val);

CSSM_RETURN cl_der_RemoveLeafNode(CSSM_CLUTIL_CONTEXT *pContext,
                                  CL_DER_NODE_HANDLE Handle);

CSSM_RETURN cl_der_RemoveParentNode(CSSM_CLUTIL_CONTEXT *pContext,
                                    CL_DER_NODE_HANDLE Handle);

void cl_der_DeleteAllNodes(CSSM_CLUTIL_CONTEXT *pContext);


void cl_der_FreeDerNodeTree(const CSSM_CLUTIL_CONTEXT *pContext,
                            DER_NODE_PTR DerNodePtr);

#endif
