/*-----------------------------------------------------------------------
 * File: API_SHIM.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

#ifndef __API_SHIM_H__
#define __API_SHIM_H__



CSSM_RETURN 
addin_SignData (CSSM_CC_HANDLE CCHandle,
               const CSSM_DATA *DataBufs,
               uint32 DataBufCount,
               CSSM_ALGORITHMS DigestAlgorithm,
               CSSM_DATA_PTR Signature);

CSSM_RETURN 
addin_VerifyData (CSSM_CC_HANDLE CCHandle,
                   const CSSM_DATA *DataBufs,
                   uint32 DataBufCount,
                   CSSM_ALGORITHMS DigestAlgorithm, 
                   const CSSM_DATA *Signature);

CSSM_RETURN 
addin_DigestData (CSSM_CC_HANDLE CCHandle,
                  const CSSM_DATA *DataBufs,
                  uint32 DataBufCount,
                  CSSM_DATA_PTR Digest);

CSSM_RETURN 
addin_DeleteContext (CSSM_CC_HANDLE CCHandle);

CSSM_RETURN 
addin_GetContext (CSSM_CC_HANDLE CCHandle,
                  CSSM_CONTEXT_PTR *Context);

CSSM_RETURN 
addin_FreeContext (CSSM_CONTEXT_PTR Context);



/* CSP interfaces */
CSSM_RETURN 
addin_csp_CreateSignatureContext (
                    CSSM_CSP_HANDLE CSPHandle,
                    uint32 AlgorithmID,
                    const CSSM_ACCESS_CREDENTIALS *AccessCred,
                    const CSSM_KEY *Key,
                    CSSM_CC_HANDLE *NewContextHandle );
CSSM_RETURN 
addin_csp_CreateDigestContext (CSSM_CSP_HANDLE CSPHandle,
                               CSSM_ALGORITHMS AlgorithmID,
                               CSSM_CC_HANDLE *NewContextHandle);

#endif /* __API_SHIM_H__ */

