/*-----------------------------------------------------------------------
 * File: X509OIDS.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 
#define X509CL_MODULE
#ifdef VMS
#include <string.h>
#endif

#include "oidsx509.h"
#include"cssmMemTrack.h"

OID_INT X509_CERT_OIDS[] = {
    { &CSSMOID_X509V3SignedCertificate, INT_SignedCertificate },
    { &CSSMOID_X509V3Certificate,       INT_Certificate },

    { &CSSMOID_X509V1Version,           INT_Version },
    { &CSSMOID_X509V1SerialNumber,      INT_SerialNumber },

    { &CSSMOID_X509V1IssuerName,        INT_IssuerName },

    { &CSSMOID_X509V1ValidityNotBefore, INT_ValidityNotBefore },
    { &CSSMOID_X509V1ValidityNotAfter,  INT_ValidityNotAfter },

    { &CSSMOID_X509V1SubjectName,       INT_SubjectName },

    { &CSSMOID_CSSMKeyStruct,                               INT_CSSMKeyStruct },
    { &CSSMOID_X509V1SubjectPublicKeyAlgorithm,             INT_SubjectPublicKeyAlgorithm },
    { &CSSMOID_X509V1SubjectPublicKeyAlgorithmParameters,   INT_SubjectPublicKeyAlgorithmParameters },
    { &CSSMOID_X509V1SubjectPublicKey,                      INT_SubjectPublicKey },

    { &CSSMOID_X509V1CertificateIssuerUniqueId,     INT_CertificateIssuerUniqueId },
    { &CSSMOID_X509V1CertificateSubjectUniqueId,    INT_CertificateSubjectUniqueId },

    { &CSSMOID_X509V3CertificateNumberOfExtensions, INT_CertificateNumberOfExtensions },
    { &CSSMOID_X509V3CertificateExtensionStruct,    INT_CertificateExtensionStruct },
    { &CSSMOID_X509V3CertificateExtensionId,        INT_CertificateExtensionId },
    { &CSSMOID_X509V3CertificateExtensionCritical,  INT_CertificateExtensionCritical },
    { &CSSMOID_X509V3CertificateExtensionType,      INT_CertificateExtensionType },
    { &CSSMOID_X509V3CertificateExtensionValue,     INT_CertificateExtensionValue },

    { &CSSMOID_X509V1SignatureStruct,               INT_SignatureStruct },
    { &CSSMOID_X509V1SignatureAlgorithm,            INT_SignatureAlgorithm },
    { &CSSMOID_X509V1SignatureAlgorithmParameters,  INT_SignatureAlgorithmParameters },
    { &CSSMOID_X509V1Signature,                     INT_Signature },

    { &CSSMOID_X509V3SignedCertificateCStruct,      INT_SignedCertificateCStruct },
    { &CSSMOID_X509V3CertificateCStruct,            INT_CertificateCStruct },

    { &CSSMOID_X509V1IssuerNameCStruct,             INT_IssuerNameCStruct },
    { &CSSMOID_X509V1IssuerNameLDAP,                INT_IssuerNameLDAP },

    { &CSSMOID_X509V1SubjectNameCStruct,            INT_SubjectNameCStruct },
    { &CSSMOID_X509V1SubjectNameLDAP,               INT_SubjectNameLDAP },

    { &CSSMOID_X509V1SubjectPublicKeyCStruct,       INT_SubjectPublicKeyCStruct },

    { &CSSMOID_X509V3CertificateExtensionsCStruct,  INT_CertificateExtensionsCStruct },

    { &CSSMOID_X509V1SignatureCStruct,              INT_SignatureCStruct }

/*
    { &CSSMOID_X509V3CertificateExtensionsStruct,   INT_CertificateExtensionsStruct }, 
    { &CSSMOID_X509V3CertificateExtensionCStruct,   INT_CertificateExtensionCStruct }, 
    { &CSSMOID_X509ExtBasicConstraints,             INT_ExtBasicConstraints },
    { &CSSMOID_X509ExtPrivateUseExemptions,         INT_ExtPrivateUseExemptions }
*/
};


OID_INT X509_CRL_OIDS[] = {
    { &CSSMOID_X509V2CRLSignedCrlStruct,    INT_CRLSignedCrlStruct },
    { &CSSMOID_X509V2CRLTbsCertListStruct,  INT_CRLTbsCertListStruct },
    
    { &CSSMOID_X509V2CRLVersion,            INT_CRLVersion },
    { &CSSMOID_X509V1CRLIssuerStruct,       INT_CRLIssuerStruct },
    { &CSSMOID_X509V1CRLThisUpdate,         INT_CRLThisUpdate },
    { &CSSMOID_X509V1CRLNextUpdate,         INT_CRLNextUpdate },

    { &CSSMOID_X509V1CRLRevokedCertificatesStruct,      INT_CRLRevokedCertificatesStruct },
    { &CSSMOID_X509V1CRLNumberOfRevokedCertEntries,     INT_CRLNumberOfRevokedCertEntries },
    { &CSSMOID_X509V1CRLRevokedEntryStruct,             INT_CRLRevokedEntryStruct },
    { &CSSMOID_X509V1CRLRevokedEntrySerialNumber,       INT_CRLRevokedEntrySerialNumber },
    { &CSSMOID_X509V1CRLRevokedEntryRevocationDate,     INT_CRLRevokedEntryRevocationDate },
    { &CSSMOID_X509V2CRLRevokedEntryAllExtensionsStruct,INT_CRLRevokedEntryAllExtensionsStruct },
    { &CSSMOID_X509V2CRLRevokedEntryNumberOfExtensions, INT_CRLRevokedEntryNumberOfExtensions },
    { &CSSMOID_X509V2CRLRevokedEntrySingleExtensionStruct,INT_CRLRevokedEntrySingleExtensionStruct },
    { &CSSMOID_X509V2CRLRevokedEntryExtensionId,        INT_CRLRevokedEntryExtensionId },
    { &CSSMOID_X509V2CRLRevokedEntryExtensionCritical,  INT_CRLRevokedEntryExtensionCritical },
    { &CSSMOID_X509V2CRLRevokedEntryExtensionType,      INT_CRLRevokedEntryExtensionType },
    { &CSSMOID_X509V2CRLRevokedEntryExtensionValue,     INT_CRLRevokedEntryExtensionValue },

    { &CSSMOID_X509V2CRLAllExtensionsStruct,    INT_CRLAllExtensionsStruct },
    { &CSSMOID_X509V2CRLNumberOfExtensions,     INT_CRLNumberOfExtensions },
    { &CSSMOID_X509V2CRLSingleExtensionStruct,  INT_CRLSingleExtensionStruct },
    { &CSSMOID_X509V2CRLExtensionId,            INT_CRLExtensionId },
    { &CSSMOID_X509V2CRLExtensionCritical,      INT_CRLExtensionCritical },
    { &CSSMOID_X509V2CRLExtensionType,          INT_CRLExtensionType },
    { &CSSMOID_X509V2CRLExtensionValue,         INT_CRLExtensionValue },

    { &CSSMOID_X509V1SignatureStruct,           INT_CRLSignatureStruct },
    { &CSSMOID_X509V1SignatureAlgorithm,        INT_CRLSignatureAlgorithm },
    { &CSSMOID_X509V1SignatureAlgorithmParameters, INT_CRLSignatureAlgorithmParameters },
    { &CSSMOID_X509V1Signature,                 INT_CRLSignature },
    
    { &CSSMOID_X509V2CRLSignedCrlCStruct,       INT_CRLSignedCrlCStruct },
    { &CSSMOID_X509V2CRLTbsCertListCStruct,     INT_CRLTbsCertListCStruct },

    { &CSSMOID_X509V1CRLIssuerNameCStruct,      INT_CRLIssuerNameCStruct },
    { &CSSMOID_X509V1CRLIssuerNameLDAP,         INT_CRLIssuerNameLDAP },
    
    { &CSSMOID_X509V1CRLRevokedCertificatesCStruct, INT_CRLRevokedCertificatesCStruct },

    { &CSSMOID_X509V2CRLRevokedEntryAllExtensionsCStruct,   INT_CRLRevokedEntryAllExtensionsCStruct },

    { &CSSMOID_X509V2CRLAllExtensionsCStruct,   INT_CRLAllExtensionsCStruct },

    { &CSSMOID_X509V1SignatureCStruct,          INT_CRLSignatureCStruct },

    { &CSSMOID_X509V1CRLRevokedEntryCStruct,        INT_CRLRevokedEntryCStruct }
/*    { &CSSMOID_X509V2CRLRevokedEntrySingleExtensionCStruct,   INT_CRLRevokedEntrySingleExtensionCStruct }, */
/*    { &CSSMOID_X509V2CRLSingleExtensionCStruct, INT_CRLSingleExtensionCStruct }, */
};



CSSM_BOOL x509_cl_IsEqualOid(CSSM_OID_PTR Oid1, CSSM_OID_PTR Oid2)
{
    if ((Oid1->Length == Oid2->Length) 
        && (memcmp(Oid1->Data, Oid2->Data, Oid1->Length) == 0) )
        return CSSM_TRUE;
    return CSSM_FALSE;
}

int x509_cl_CertOidToInt(CSSM_OID Oid)
{
    int i;

    for (i=0; i < NUMBER_X509_CERT_OIDS; i++)
    {
        if (x509_cl_IsEqualOid(&Oid, X509_CERT_OIDS[i].oidval)) 
            return X509_CERT_OIDS[i].intval;
    }

    return INT_NoMatch;
}

CSSM_BOOL IsX509V3CertOid( CSSM_OID Oid )
{
    return ((x509_cl_CertOidToInt(Oid) == INT_NoMatch) ? CSSM_FALSE : CSSM_TRUE);
}


int x509_cl_CrlOidToInt(CSSM_OID Oid)
{
    int i;

    for (i=0; i < NUMBER_X509_CRL_OIDS; i++)
    {
        if (x509_cl_IsEqualOid(&Oid, X509_CRL_OIDS[i].oidval)) 
            return X509_CRL_OIDS[i].intval;
    }

    return INT_NoMatch;
}

CSSM_BOOL IsX509V2CrlOid(CSSM_OID Oid)
{
    return ((x509_cl_CrlOidToInt(Oid) == INT_NoMatch) ? CSSM_FALSE : CSSM_TRUE);
}

int x509_cl_OidToInt(CSSM_OID Oid)
{
    int i;

    for (i=0; i < NUMBER_X509_CERT_OIDS; i++)
    {
        if (x509_cl_IsEqualOid(&Oid, X509_CERT_OIDS[i].oidval)) 
            return X509_CERT_OIDS[i].intval;
    }

    for (i=0; i < NUMBER_X509_CRL_OIDS; i++)
    {
        if (x509_cl_IsEqualOid(&Oid, X509_CRL_OIDS[i].oidval)) 
            return X509_CRL_OIDS[i].intval;
    }

    return INT_NoMatch;
}
