/*-----------------------------------------------------------------------
 * File: PASSTHRU.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "maf_include.h"

#include "cssm.h"
#include "x_fndefs.h"
#include "maf_interface.h"
#include <cssmMemTrack.h>

/*-----------------------------------------------------------------------------
 * Name: CL_PassThrough
 *
 * Description:
 * This function allows applications to call CSSM CL module-specific operations.
 * The CSSM CL module-specific operations include
 * 
 * Parameters: 
 * CCHandle (input)       : Handle identifying a Cryptographic Context which
 *                          may be used by the pass-through function
 * PassThroughId (input)  : An identifier assigned by the CSSM CL module 
 *                          to indicate the exported function to perform.
 * InputParams (input)    : Parameters to be interpreted in a 
 *                          function-specific manner by the CSSM CL module.
 *
 * Return value:
 * Output from the pass-through function.  
 * The output data must be interpreted by the calling application 
 * based on externally available information.
 *
 *---------------------------------------------------------------------------*/

CSSM_RETURN CSSMCLI CL_PassThrough(CSSM_CL_HANDLE CLHandle,
                                CSSM_CC_HANDLE CCHandle, 
                                uint32 PassThroughId, 
                                const void * InputParams,
                                void **result_val)
{
    
    
    return CSSMERR_CL_FUNCTION_NOT_IMPLEMENTED;
} 

