/*-----------------------------------------------------------------------
 * File: OPSTATS.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "cspinc.h"

CSSM_RETURN CSSMAPI ADDIN_CSM_GetOperationalStatistics(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_CSP_OPERATIONAL_STATISTICS *Statistics )
{
    CSSM_RETURN rv = CSSM_OK;

    /* CSP does not support login authentication */
    Statistics->UserAuthenticated = CSSM_FALSE;

    /* Indicate the key storage and protection policy supported by the
     * key manager.
     */
    Statistics->DeviceFlags = ( CSSM_CSP_TOK_SESSION_KEY_PASSWORD |
                                CSSM_CSP_TOK_PRIVATE_KEY_PASSWORD |
                                CSSM_CSP_STORES_PRIVATE_KEYS |
                                CSSM_CSP_STORES_PUBLIC_KEYS |
                                CSSM_CSP_STORES_SESSION_KEYS );

    /* This information is irrelivant to this CSP. Mostly concerned with
     * hardware CSPs.
     */
    Statistics->TokenMaxSessionCount = CSSM_VALUE_NOT_AVAILABLE;
    Statistics->TokenOpenedSessionCount = CSSM_VALUE_NOT_AVAILABLE;
    Statistics->TokenMaxRWSessionCount = CSSM_VALUE_NOT_AVAILABLE;
    Statistics->TokenOpenedRWSessionCount = CSSM_VALUE_NOT_AVAILABLE;
    Statistics->TokenTotalPublicMem = CSSM_VALUE_NOT_AVAILABLE;
    Statistics->TokenFreePublicMem = CSSM_VALUE_NOT_AVAILABLE;
    Statistics->TokenTotalPrivateMem = CSSM_VALUE_NOT_AVAILABLE;
    Statistics->TokenFreePrivateMem = CSSM_VALUE_NOT_AVAILABLE;

    return rv;
}
