/*-----------------------------------------------------------------------
 * File: GENINC.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _GENINC_H
#define _GENINC_H

#include "maf_include.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Error checking headers */
#include <assert.h>

/* MAF Configuration Header */
#include "maf_config.h"

/* MAF Key Manager */
#include "csm_keymgr.h"

/* BSafe Header Files */
#include "aglobal.h"
#include "atypes.h"
#include "bsafe.h"

/* CSP Utility Headers */
#include "csp_defs.h"
#include "csp_util.h"
#include "csp_strt.h"
#include "keyconv.h"

#ifdef __cplusplus
} /* extern "C" */
#endif

/* General Purpose Macros */
#define CHECKBITS( value, mask ) ( ( value & mask ) == mask )

/* Function to convert BSafe error codes to CDSA error codes. */
uint32 ConvertBsafeError(int error);

CSSM_RETURN csp_InitRandom(CSSM_ALGORITHMS algid, B_ALGORITHM_OBJ *randomNumGen);

CSSM_RETURN bsafe_CheckKeyParams(
                        CSSM_ALGORITHMS AlgId,
                        uint32 KeyLength );

#endif
