/*-----------------------------------------------------------------------
 * File: KMG_CALLOUTS.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "maf_include.h"

/* Example key manager wrapping parameters */
#define KMGR_KEY_LENGTH_BYTES       ( 24 )
#define KMGR_IV_LENGTH_BYTES        ( 8 )
#define KMGR_ENCRYPT_ALG            CSSM_ALGID_3DES_3KEY
#define KMGR_ENCRYPT_MODE           CSSM_ALGMODE_CBCPadIV8

CSSM_RETURN CSSMAPI CSM_KMCallout_GetWrapParams(
                        uint32 *pKeyLengthBytes,
                        uint32 *pIVLengthBytes,
                        CSSM_ALGORITHMS *pAlgId,
                        CSSM_ENCRYPT_MODE *pAlgMode )
{
    *pKeyLengthBytes = KMGR_KEY_LENGTH_BYTES;
    *pIVLengthBytes = KMGR_IV_LENGTH_BYTES;
    *pAlgId = KMGR_ENCRYPT_ALG;
    *pAlgMode = KMGR_ENCRYPT_MODE;

    return CSSM_OK;
}

CSSM_RETURN CSSMAPI CSM_KMCallout_GetRandomBytes(
                        uint32 Length,
                        uint8 *RandomBytes )
{
    return CSSMERR_CSP_FUNCTION_NOT_IMPLEMENTED;
}

CSSM_RETURN CSSMAPI CSM_KMCallout_EncryptData(
                        uint8 *EncryptKey,
                        uint8 *IV,
                        const CSSM_DATA *Input,
                        CSSM_DATA_PTR Output )
{
    return CSSMERR_CSP_FUNCTION_NOT_IMPLEMENTED;
}

CSSM_RETURN CSSMAPI CSM_KMCallout_DecryptData(
                        uint8 *DecryptKey,
                        uint8 *IV,
                        const CSSM_DATA *Input,
                        CSSM_DATA_PTR Output )
{
    return CSSMERR_CSP_FUNCTION_NOT_IMPLEMENTED;
}

    

