/*-----------------------------------------------------------------------
 * File: APPLYCRL.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 


// suppress warnings in the runtime headers
#ifndef VMS
#pragma warning (disable:4201 4514 4214 4115)
#endif
#ifdef WIN32
#include <windows.h>
#endif
#include <stdio.h>
#ifndef VMS
#pragma warning (default:4201 4514 4214 4115)
#endif

/* CDSA includes */
#include "cssm.h"               /* CSSM types, errors, and APIs */
#include "cssmspi.h"            /* CSSM service provider interface */
#include "cssmtpi.h"            /* CSSM trust policy interface */

/* Intel includes */
#include "maf_include.h"

/* local includes */
#include "inx509tp.h"           /* func and data definitions 
                                   specific to this module */

#include <cssmMemTrack.h>

/*---------------------------------------------------------------
 *
 * Name: TP_ApplyCrlToDb
 *
 * Description:
 *   Given a CRL, update entries in database to reflect that a
 *   certificate has been revoked.
 *
 * Parameters: 
 *   TPHandle (input)       - Handle of the TP module
 *   CLHandle (input)       - Handle of the CL module
 *   CSPHandle (input)      - Handle of the CSP module
 *   DBlist (input)         - List of DLDBHandles to databases
 *   CrlToBeApplied (input) - 
 *   CrlType (input)        -
 *   CrlEncoding (input)    -
 *   SignerCert (input)     -
 *   SignerVerifyContext (input)
 *                          - 
 *
 * Returns:
 *   CSSM_FAIL              - unable to apply CRL to database
 *   CSSM_OK                - database is updated with CRL entries.
 *
 *-------------------------------------------------------------*/
CSSM_RETURN CSSMAPI 
TP_ApplyCrlToDb(CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_ENCODED_CRL *CrlToBeApplied,
                        const CSSM_CERTGROUP *SignerCertGroup,
                        const CSSM_TP_VERIFY_CONTEXT *ApplyCrlVerifyContext,
                        CSSM_TP_VERIFY_CONTEXT_RESULT_PTR ApplyCrlVerifyResult )
{
  /* unused parameters */
  TPHandle;
  CLHandle;
  CSPHandle;
  CrlToBeApplied;
  SignerCertGroup;
  ApplyCrlVerifyContext;
  ApplyCrlVerifyResult;

  return( CSSMERR_TP_FUNCTION_NOT_IMPLEMENTED );
}
