/*-----------------------------------------------------------------------
 * File: CERTSIGN.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

// suppress warnings in the runtime headers
#ifndef VMS
#pragma warning (disable:4201 4514 4214 4115)
#endif
#ifdef WIN32
#include <windows.h>
#endif
#include <stdio.h>
#ifndef VMS
#pragma warning (default:4201 4514 4214 4115)
/* note that error 4514 is "unreferenced inline function has been removed */
#endif
/* CDSA includes */
#include "cssm.h"               /* CSSM types, errors, and APIs */
#include "cssmspi.h"            /* CSSM service provider interface */
#include "cssmtpi.h"            /* CSSM trust policy interface */

/* Intel includes */
#include "maf_include.h"

/* local includes */
#include "inx509tp.h"           /* func and data definitions 
                                   specific to this module */
#include "api_shim.h"
#include "Chn_util.h"

#include <cssmMemTrack.h>

/*---------------------------------------------------------------
 *
 * Name: TP_CertSign
 *
 * Description:
 *   Sign a cerificate given the inputs.  This call maps directly
 *   to a call to CSSM_CL_CertSign() with the CL handle provided.
 *
 * Parameters: 
 *   TPHandle (input)     - Handle of the TP module
 *   CLHandle (input)     - Handle of the CL module
 *   CCHandle (input)     - Handle of the cryptographic context
 *                          for signing the certificate
 *   DBList (input)       - List of DLDBHandles to databases
 *                          [unused - must be NULL]
 *   CertToBeSigned (input)
 *                        - pointer to the certificate that 
 *                          needs signature
 *   SignerCertGroup (input)
 *                        - pointer to the certificate group that 
 *                          will sign the SubjectCert certificate.
 *   SignerVerifyContext (input)
 *                        -
 *   SignScope (input)    - pointer to data that describes the 
 *                          signature scope.
 *                          [unused - must be NULL]
 *   ScopeSize (input)    - number of entries in SignScope
 *                          [unused - must be zero]
 *
 * Returns:
 *   NULL - unable to sign certificate
 *   non NULL - pointer to the signed certificate
 *
 *-------------------------------------------------------------*/
CSSM_RETURN CSSMAPI 
TP_CertSign( CSSM_TP_HANDLE TPHandle, 
             CSSM_CL_HANDLE CLHandle, 
             CSSM_CC_HANDLE CCHandle, 
             const CSSM_DATA *CertToBeSigned, 
             const CSSM_CERTGROUP *SignerCertGroup,
             const CSSM_TP_VERIFY_CONTEXT *SignerVerifyContext,
             CSSM_TP_VERIFY_CONTEXT_RESULT_PTR SignerVerifyResult,
             CSSM_DATA_PTR SignedCert
             )

{
  SignedCert;
  SignerVerifyResult;
  SignerVerifyContext;
  SignerCertGroup;
  CertToBeSigned;
  CCHandle;
  CLHandle;
  TPHandle;

  return( CSSMERR_TP_FUNCTION_NOT_IMPLEMENTED );
}
