/*-----------------------------------------------------------------------
 * File: CRTGRPPR.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

/* CSSM INCLUDES */
#include "cssm.h"
#include "cssmtpi.h"
#include "cssmspi.h"

/* LOCAL INCLUDES */
#include "inx509tp.h"           /* func and data definitions specific to this module */
#include "api_shim.h"
#include "maf_include.h"

#include <cssmMemTrack.h>

/*-----------------------------------------------------------------------------
 * Name: TP_CertGroupPrune
 *
 * Description:
 * This function prunes a cert group to an exportable fragment. It removes all 
 * local CA-issued certs and all root certs.  
 *
 * Parameters: 
 * TPHandle (input)
 * CLHandle (input)
 * DBList (input)    
 * OrderedCertGroup (input)
 *
 * Return value:
 * The pruned cert group on success.
 * NULL on error
 *
 * Error Codes:
 * -TBD-
 *
 *---------------------------------------------------------------------------*/
CSSM_RETURN CSSMAPI 
TP_CertGroupPrune(CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DL_DB_LIST *DBList,
                        const CSSM_CERTGROUP *OrderedCertGroup,
                        CSSM_CERTGROUP_PTR *PrunedCertGroup )
{
    /* unused parameters */
    TPHandle;
    CLHandle;
    DBList;
    OrderedCertGroup;
    PrunedCertGroup;

    return(CSSMERR_TP_FUNCTION_NOT_IMPLEMENTED);
}
