/*-----------------------------------------------------------------------
 * File: INX509TP.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 


#ifndef _INX509TP_H
#define _INX509TP_H

#ifdef WIN32
#include <windows.h>
#endif
#include <stdio.h>              

/* CDSA includes */
#include "cssm.h"               /* CSSM types, errors, and APIs */
#include "cssmspi.h"            /* CSSM service provider interface */
#include "cssmtpi.h"            /* CSSM trust policy interface */

/* X.509 includes */
#include "x509defs.h"           /* defines basic x.509 types */

#define NOCOMM
#define BUFSIZE 180
/* defines the maximum depth that a cert chain is expected to reach */
#define MAX_CHAIN_DEPTH 50


/* structure to be used in the reserved field of a certificate group */
typedef struct
{
    uint32 IndexToRootCert;
} CSSM_TP_X509V3_GRP_INFO, *CSSM_TP_X509V3_GRP_INFO_PTR;




#endif /* _INX509TP_H */
