/*-----------------------------------------------------------------------
 * File: dummyemmadinfnspi.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

#ifndef _DUMMYEMMADDINFNSPI_H
#define _DUMMYEMMADDINFNSPI_H    

#ifdef __cplusplus
extern "C" {
#endif

/* Calling convention for the DL SPI functions */
#define CSSMEMMSPI CSSMAPI

/* Define a function pointer type for each SPI function. The pointer types 
 * are named _CSSM_CSSMEMMSPI_XXX_PTR, where XXX is the value of the SPI.
 */
typedef CSSM_RETURN (CSSMEMMSPI *_CSSM_CSSMEMMSPI_Passthru_PTR)(
                        CSSM_MODULE_HANDLE Handle,
                        CSSM_SERVICE_TYPE ServiceType );

typedef CSSM_RETURN (CSSMEMMSPI *_CSSM_CSSMEMMSPI_Passthru1_PTR)(
                        CSSM_MODULE_HANDLE Handle,
                        CSSM_SERVICE_TYPE ServiceType);


/* Define a function pointer interface table for the SPI.
 */
typedef struct cssm_spi_emm_funcs {
    _CSSM_CSSMEMMSPI_Passthru_PTR                       Passthru;
    _CSSM_CSSMEMMSPI_Passthru1_PTR                      Passthru1;
} CSSM_SPI_EMMADDIN_FUNCS, *CSSM_SPI_EMMADDIN_FUNCS_PTR;

#ifdef __cplusplus
}
#endif

#endif /* ifndef _DUMMYEMMADDINFNSPI_H */
