/*-----------------------------------------------------------------------
 * File: DUMMYMULTIACI.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/**************************************************************************
 **************************************************************************

 NEVER MODIFY THE .C VERSION OF THIS FILE BY HAND. IT IS GENERATED USING
 THE SCRIPTS IN THE ./generate DIRECTORY. TO UPDATE THE FILE, CHANGE THE
 .ctp FILE WITH THE SAME NAME AND TYPE 'make' FOLLOWED BY 'make install'.

 **************************************************************************
 **************************************************************************/

#include "maf_include.h"

#include "dummymultiaci_err.h"

/* Define each SPI function.
 */
CSSM_RETURN CSSMACI AC_AuthCompute(
                    CSSM_AC_HANDLE ACHandle,
                    const CSSM_TUPLEGROUP *BaseAuthorizations,
                    const CSSM_TUPLEGROUP *Credentials,
                    uint32 NumberOfRequestors,
                    const CSSM_LIST *Requestors,
                    const CSSM_LIST *RequestedAuthorizationPeriod,
                    const CSSM_LIST *RequestedAuthorization,
                    CSSM_TUPLEGROUP_PTR AuthorizationResult )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ACHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_AC_AUTH_COMPUTE;
}

CSSM_RETURN CSSMACI AC_PassThrough(
                    CSSM_AC_HANDLE ACHandle,
                    CSSM_TP_HANDLE TPHandle,
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    const CSSM_DL_DB_LIST *DBList,
                    uint32 PassThroughId,
                    const void *InputParams,
                    void **OutputParams )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ACHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_AC_PASS_THROUGH;
}


/* Define the attach function.
 */
CSSM_RETURN ac_ModuleAttach(
                   CSSM_MODULE_FUNCS_PTR *FuncTbl )
{
    static CSSM_MODULE_FUNCS FunctionList;
    static CSSM_SPI_AC_FUNCS Functions;
    if (!FuncTbl)
    {
        return CSSMERR_CSSM_INVALID_POINTER;
    }
    FunctionList.ServiceType = CSSM_SERVICE_AC;
    FunctionList.NumberOfServiceFuncs = sizeof(CSSM_SPI_AC_FUNCS) /
                                          sizeof(
                    CSSM_PROC_ADDR );

    FunctionList.ServiceFuncs = (CSSM_PROC_ADDR*)&Functions;
    Functions.AuthCompute = AC_AuthCompute;
    Functions.PassThrough = AC_PassThrough;
    *FuncTbl = &FunctionList;
    return CSSM_OK;
}
