/*-----------------------------------------------------------------------
 * File: CALLOUTS.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "cssm.h"


#ifdef ISL_INCLUDED

#ifdef WIN32
#include <windows.h>
#else
#include "cssmport.h"
#endif
#include "callouts.h"
#include "eislapi.h"
#include "common.h"
#include "dummy_mds.h"
#ifdef VMS
#include "intel/rootnames.h"
#else
#include "rootnames.h"
#endif
#include "mds_util_helper.h"
#include "guids.h"
CSSM_GUID intel_dummytestemm_guid = intel_dummy_test_emm_guid_3_0_0_init;

int EISL_RetrieveRootIssuerName(ISL_CALLOUT_DATA *Name)
{
Name;
return 0;
}  /* ; ifdef VMS remove extraneous semicolon */

void EISL_RetrieveSelfCheckSectionName(
    ISL_CALLOUT_DATA *Name)
{
    char *str = "indytstemm300";
    uint32 len = strlen(str);

    if (len > Name->length)
        goto FAIL;

    memcpy(Name->value, str, len+1);
    
    Name->length = len;
    return;

FAIL:
    Name->length = 0;
    return; 

}

void EISL_RetrieveSelfCheckCredentials(
        ISL_CALLOUT_DATA *Name, ISL_CALLOUT_DATA *Path)
{
    CSSM_DATA Credential;
    CSSM_DATA ModulePath;

    if (mdsutil_GetModuleCredentialInfo (&intel_dummytestemm_guid,
                                 &Credential, 
                                 NULL, 
                                 &ModulePath) == CSSM_OK) {
        memcpy (Name->value, Credential.Data, Credential.Length);
        Name->length = Credential.Length;
        memcpy (Path->value, ModulePath.Data, ModulePath.Length);
        Path->length = ModulePath.Length;
        dummy_free (Credential.Data, NULL);
        dummy_free (ModulePath.Data, NULL);
    }
}

void EISL_RetrieveSelfCheckCredentialsSize(
                            uint32 *Size)
{
    CSSM_DATA Credential;
    CSSM_DATA ModulePath;

    if (mdsutil_GetModuleCredentialInfo (&intel_dummytestemm_guid,
                                 &Credential, 
                                 NULL, 
                                 &ModulePath) == CSSM_OK) {
        if (Size)
            *Size = Credential.Length;
        dummy_free (Credential.Data, NULL);
        dummy_free (ModulePath.Data, NULL);
    }
}
#endif
