/*-----------------------------------------------------------------------
 * File: MEF_CONFIG.H
 *
 * Copyright (c) 2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _MEF_CONFIG_H_
#define _MEF_CONFIG_H_

#define NO_MODULE_STRING_NAMES
#include "guids.h"

/*Name of the EMM module */
#define EMM_NAME                            "HRS v1.0 EMM"

/* Manifest section name of the EMM */
#ifdef VMS
#define EMM_SELF_CHECK_SECTION              "cdsa$inhrsemm_shr"
#else
#define EMM_SELF_CHECK_SECTION              "inhrsemm100"
#endif

/* GUID of the EMM module */
#define EMM_GUID_INITIALIZER                intel_hrs_emm_guid_init


/* Major version of the compatible CDSA spec */
#define CDSA_VERSION_MAJOR                  CSSM_MAJOR

/* Minor version of the compatible CDSA spec */
#define CDSA_VERSION_MINOR                  CSSM_MINOR


/* Major version of the compatible EMM spec */
#define EMM_VERSION_MAJOR                   HRS_VERSION_MAJOR

/* Minor version of the compatible EMM spec */
#define EMM_VERSION_MINOR                   HRS_VERSION_MINOR


/* Major version of this EMM implementation (product version) */
#define PRODUCT_VERSION_MAJOR               INTEL_HRS_EMM_MAJOR_VER

/* Minor version of this EMM implementation (product version) */
#define PRODUCT_VERSION_MINOR               INTEL_HRS_EMM_MINOR_VER


/* Vendor Name */
#define EMM_VENDOR_NAME                     "Intel Corporation"

/* EMM Type */
#define EMM_TYPE                            CSSM_SERVICE_HRS

#endif  /* _MEF_CONFIG_H_ */
