/*-----------------------------------------------------------------------
 * File: MEF_INCLUDE.H
 *
 * Copyright (c) 2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _MEF_INCLUDE_H_
#define _MEF_INCLUDE_H_


/* general CDSA API includes */
#include "cssm.h"
#include "guids.h"


/* EMM header files */
#include "emmtype.h"
#include "emmspi.h"


/* standard includes */
#include <time.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>


/* OS Specific includes */
#if defined(WIN32)
#pragma warning (disable:4201 4514 4214 4115)
#include <regstr.h>
#include <process.h>
#include <assert.h>
#pragma warning (default:4201 4214 4115)
#endif


/* CSSM utility library includes */
#include "cssmport.h"
#include "cssmlock.h"


/* MDS-related header files */
#include "mds.h"
#include "mds_schema.h"
#ifdef VMS
#include <mds_util.h>
#else
#include "../../../fwk/mds_util/mds_util.h"
#endif

/* installer definitions */
#include "intel/installdefs.h"


/* integrity-related header files - including an internal header */
#ifdef ISL_INCLUDED
#include "isltype.h"
#include "eislapi.h"
#endif  /* ISL_INCLUDED */


/* local header files */
#include "mef_interface.h"
#include "mef_mds.h"
#include "mef_manage.h"
#include "mef_integ.h"


/* header file for EMM function customization */
#include "emm_callouts.h"


#endif  /* _MEF_INCLUDE_H_ */
