/*-----------------------------------------------------------------------
 * File: MEF_MANAGE.H
 *
 * Copyright (c) 2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _MEF_MANAGE_H_
#define _MEF_MANAGE_H_


/************************************************************************/
/* These functions are only to be called from DllMain, _init()/_fini(), */
/* or their equivalents in other OS's.                                  */
/************************************************************************/

CSSM_RETURN
mef_InitManage();

CSSM_RETURN
mef_FiniManage();

/************************************************************************/

CSSM_RETURN
mef_RegisterDispatchTable(CSSM_STATE_FUNCS_PTR CssmStateCallTable,
                          CSSM_PROC_ADDR CssmRetAddress);

CSSM_RETURN
mef_DeregisterDispatchTable(CSSM_PROC_ADDR CssmRetAddress);


/* this function returns a pointer to the CSSM function table - it does
   NOT allocate memory in this call
*/
CSSM_RETURN
mef_SetUpAndGetAttachFuncs(const CSSM_GUID *CSSM_Guid,
                           CSSM_MODULE_HANDLE AttachHandle,
                           CSSM_SERVICE_TYPE ServiceType,
                           CSSM_STATE_FUNCS_PTR *CSSMFuncs,
                           void **CallBack,
                           CSSM_GUID_PTR SPGuid);


CSSM_RETURN
mef_CheckFuncCallValidity(const CSSM_STATE_FUNCS *CSSMFuncs,
                          CSSM_MODULE_HANDLE AttachHandle,
                          CSSM_PROC_ADDR SrcAddress,
                          CSSM_PROC_ADDR DestAddress,
                          CSSM_PRIVILEGE InPriv,
                          CSSM_PRIVILEGE *OutPriv,
                          CSSM_BITMASK Hints);


CSSM_RETURN
mef_CleanUpAndReleaseAttachFuncs(CSSM_MODULE_HANDLE AttachHandle,
                                 const CSSM_STATE_FUNCS *CSSMFuncs);


#endif /* _MEF_MANAGE_H_ */
