/*-----------------------------------------------------------------------
 * File: MAF_DBG.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */
#include "maf_include.h"

#define MAF_DBG_MAX_MESSAGE_LEN     ( 256 )


/**-------------------------------------------------------------------------
 ** MAF_OutputDebugString
 **
 ** Description:
 **  Outputs a debug message to the application or system debug console if
 **  one exists. The string referenced by pString must be NULL terminated
 **  and will have a newline appended before sending it to the console.
 ** 
 ** Parameters: 
 **  pString (input)    - The debug string
 *--------------------------------------------------------------------------
 **/
void MAF_OutputDebugString(const char* pString)
{
#ifdef _DEBUG
    if (pString)
    {
        OutputDebugString(pString);
        OutputDebugString("\n");
    }
#else
    /* Unused parameter */
    pString;
#endif
}

