/*-----------------------------------------------------------------------
 * File: MAF_MISC.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 
#ifndef __MAF_MISC_H__
#define __MAF_MISC_H__

#define MAF_ALLOCATE_LOCAL              ( 0 )

#define MAF_MALLOC( _handle, _size ) \
    ( _handle == MAF_ALLOCATE_LOCAL ) ? Addin_malloc( _size, NULL ) : \
                                        App_Malloc( _handle, _size )
#define MAF_CALLOC( _handle, _size, _count ) \
    ( _handle == MAF_ALLOCATE_LOCAL ) ? \
                                Addin_calloc( _size, _count, NULL ) : \
                                App_Calloc( _handle, _size, _count )
#define MAF_REALLOC( _handle, _buf, _size ) \
    ( _handle == MAF_ALLOCATE_LOCAL ) ? \
                                Addin_realloc( _buf, _size, NULL ) : \
                                App_Realloc( _handle, _buf, _size )
#define MAF_FREE( _handle, _buf ) \
    ( _handle == MAF_ALLOCATE_LOCAL ) ? Addin_free( _buf, NULL ) : \
                                        App_Free( _handle, _buf )

CSSM_RETURN MAF_CreateOutputBuffer( CSSM_MODULE_HANDLE ModuleHandle,
                                   uint32 uRequiredSize,
                                   CSSM_DATA *pOutBuffer,
                                   CSSM_BOOL *pbAllocated );

CSSM_RETURN MAF_DeleteOutputBuffer( CSSM_MODULE_HANDLE ModuleHandle,
                                   CSSM_DATA *pOutBuffer,
                                   CSSM_BOOL bAllocated );

CSSM_RETURN MAF_ResolveCryptoData( const CSSM_CRYPTO_DATA *pCryptoData,
                                  CSSM_DATA *pResolvedData,
                                  uint32 uMaxLength,
                                  CSSM_BOOL *pbAllocated );

#define MAF_PRINTABLE_GUID_LENGTH       ( 40 )
#define MAF_PRINTABLE_VERSION_LENGTH    ( 8 )

CSSM_RETURN MAF_GetPrintableGUID( const CSSM_GUID *pGUID,
                                 char *PrintableGUID );

CSSM_RETURN MAF_GetStructuredGUID( const char *PrintableGUID,
                                  CSSM_GUID *pGUID );

CSSM_RETURN MAF_GetPrintableVersion( const CSSM_VERSION *pVersion,
                                    char *PrintableVersion );

CSSM_RETURN MAF_GetStructuredVersion( const char *PrintableVersion,
                                     CSSM_VERSION *pVersion );

CSSM_RETURN MAF_SystemPath2FileURL( const char *SystemPath,
                                   char *FileURL );

CSSM_RETURN MAF_FileURL2SystemPath( const char *FileURL,
                                   char *SystemPath );

#endif /* ifndef __MAF_MISC_H__ */
