/***************************************************************************/
/* cpsexp.h                                                                */
/*                                                                         */
/*  Routines for parsing S-expressions into a CSSM_LIST.                   */
/***************************************************************************/

#if !defined( __PSEXP_H__ )
#define __PSEXP_H__

#include "cssmtype.h"
#include "clutil.h"
#include "strread.h"

/***************************************************************************/
/* cp_lth                                                                  */
/*                                                                         */
/* Read the length field from the current string reader.                   */
/***************************************************************************/

CSSM_RETURN cp_lth( uint32 *pRes, pSreader s ) ;

/***************************************************************************/
/* cp_bytes                                                                */
/*                                                                         */
/* Parse a byte string from the current string reader and pack it into     */
/* a new byte string block.                                                */
/***************************************************************************/

CSSM_RETURN cp_bytes( CSSM_DATA *ppb, pSreader s ) ;

/***************************************************************************/
/* cp_sexp                                                                 */
/*                                                                         */
/* Parse an S-expression from a string block.                              */
/* An S-expression is enclosed in "()" and starts with a byte string.      */
/* Look up the byte string it starts with.                                 */
/***************************************************************************/

CSSM_RETURN cp_sexp( CSSM_LIST *pps, pSreader s ) ;

/***************************************************************************/
/* cl_lit_sexp                                                                */
/*                                                                         */
/* Parse and return a literal S-expression.                                */
/***************************************************************************/

CSSM_RETURN cl_lit_sexp( CSSM_LIST *pps, uint8 *lit ) ;

#endif /* __PSEXP_H__ */
