/***************************************************************************/
/* lit_bs.c								   */
/*									   */
/* The routine to create an S_BS node from a word lookup int value.	   */
/***************************************************************************/

#include "cwordtab.h"
#include "sexp.h"
#include "free.h"

/***************************************************************************/
/* lit_bs								   */
/*									   */
/* Build and return a pBytes filled with the spelling that goes with	   */
/* the wordid given.							   */
/***************************************************************************/

pBytes lit_bs( int wid )
{
  CSSM_DATA *d = get_spelling( wid ) ;
  pBytes ans = new_bytes() ;

  if (ans == NULL) return ( NULL ) ; /* failure */
  ans->lu = wid ;		/* fill in trhe word id */
  ans->v_lth = d->Length ;	/* ... */
  ans->val = d->Data ;		/* ... */
  return ( ans ) ;
} /* lit_bs */
