
/*-----------------------------------------------------------------------
 * File: SPKIUTIL.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _SPKIUTIL_H
#define _SPKIUTIL_H    

#include "cssm.h"
#include "sexp.h"
#include "strread.h"
#include "tuple.h"
#include "spkidefs.h"
#ifdef __cplusplus                                          
extern "C" {
#endif

void dump_free_cache( void );
    
void fill_tuple( CSSM_TUPLE *t, CSSM_LIST_ELEMENT *x ); 
void pack_tuple( uint8 **pW, CSSM_TUPLE *t );
uint32 size_tuple( CSSM_TUPLE *t );
void pack_certuple( uint8 **pW, CSSM_TUPLE *t );
CSSM_RETURN fill_params( uint32 inblth, uint8 inbuff[],
                         CSSM_TUPLEGROUP *acl,
                         CSSM_TUPLEGROUP *cred,
                         uint32 max_nreq, /* allocation length for req */
                         uint32 *nreq,
                         CSSM_LIST req[],
                         CSSM_LIST *valid,
                         CSSM_LIST *tag );

CSSM_RETURN cl_lit_sexp( CSSM_LIST *pps, uint8 *lit );
void drop_cssm_tuple( CSSM_TUPLE *t );
CSSM_LIST_ELEMENT_PTR new_element( void ) ;
void init_list( CSSM_LIST *cl ) ;
uint32 size_list( CSSM_LIST *s );
void pack_list( uint8 **pW, CSSM_LIST *s );
void drop_list( CSSM_LIST *cl ) ;
void drop_sexp( pSexp h );
CSSM_RETURN tg_to_acl( CSSM_TUPLEGROUP *tgdout, CSSM_DATA *dout );
void drop_tuplegroup( CSSM_TUPLEGROUP *tg );

CSSM_RETURN AddKeyToPrincipal(uint8 *Sexp,
							  CSSM_KEY_PTR keyptr,
							  CSSM_LIST_PTR result);


CSSM_RETURN CssmKeyToSexp(CSSM_KEY_PTR keyptr,
                          CSSM_LIST_PTR KeyAsList,
                          CSSM_DATA *result);


CSSM_RETURN PKListTOCssmKey(CSSM_CSP_HANDLE CSPHandle,
                            CSSM_LIST *PKList, 
                            CSSM_KEY_PTR keyptr);


void hashtab_init( void );
void hashtab_clear( void );
int hash_lookup( pSexp s, pRenlists *pRl );


void lpass0( uint32 ns, const CSSM_LIST subj[] );
void tgpass0( const CSSM_TUPLEGROUP *tg );
void lactivate( uint32 ns, const CSSM_LIST subj[] );

CSSM_RETURN cp_sexp( CSSM_LIST *pps, pSreader s ) ;
pSexp cl_to_sexp( const CSSM_LIST *subj ) ;
CSSM_RETURN sexp_to_cl( CSSM_AC_HANDLE ACHandle, CSSM_LIST *ol, pSexp s ) ;


CSSM_RETURN PKCS_DSASigBSafe2PKCS( CSSM_DATA *pBSafe );
CSSM_RETURN PKCS_DSASigPKCS2BSafe( CSSM_DATA *pPKCS11 );


CSSM_RETURN tg_reduce1( const CSSM_TUPLEGROUP *tg, /* the tuple group */
                        int active, /* BOOL:  activity of tuples */
                        pSexp sbj, /* the subject constraint */
                        pSexp tag, /* the tag constraint */
                        pSexp now /* the date constraint */
                      ) ;

CSSM_RETURN tg_report_results( CSSM_AC_HANDLE ach,	/* .. */
			       CSSM_TUPLEGROUP_PTR aout ); /* output param */

CSSM_BOOL spki_IsEquivalentCertGroup (CSSM_CERTGROUP_PTR CertGrp1, CSSM_CERTGROUP_PTR CertGrp2);
CSSM_BOOL IsEquivalentCssmData(CSSM_DATA_PTR Data1, CSSM_DATA_PTR Data2);
CSSM_RETURN CreateSPKITBSCert(CSSM_SPKI_TBSCERT_PTR Parts,
                              CSSM_DATA *TBSCert);


CSSM_RETURN HandleLegacyIntegers(const CSSM_LIST *SigList, 
                                 const CSSM_LIST *PKList);

#ifdef __cplusplus
}
#endif

#endif /* _SPKIUTIL_H */
