/*-----------------------------------------------------------------------
 * File: CSSM_CODEFILE.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/*********************************************************
 * File name: cssm_codefile.h                                 *
 * Contains codes associated with framework functions    *
 *********************************************************/

#ifdef  DO_TRACE

#ifndef _CSSM_CODEFILE_H
#define _CSSM_CODEFILE_H

#define FNCODE_CSSM_CL_CertAbortQuery                                (CSSM_BASE_CODE        +   1)
#define FNCODE_CSSM_CL_CertCreateTemplate                            (CSSM_BASE_CODE        +   2)
#define FNCODE_CSSM_CL_CertDescribeFormat                            (CSSM_BASE_CODE        +   3)
#define FNCODE_CSSM_CL_CertExport                                    (CSSM_BASE_CODE        +   4)
#define FNCODE_CSSM_CL_CertGetAllFields                              (CSSM_BASE_CODE        +   5)
#define FNCODE_CSSM_CL_CertGetFirstFieldValue                        (CSSM_BASE_CODE        +   6)
#define FNCODE_CSSM_CL_CertGetKeyInfo                                (CSSM_BASE_CODE        +   7)
#define FNCODE_CSSM_CL_CertGetNextFieldValue                         (CSSM_BASE_CODE        +   8)
#define FNCODE_CSSM_CL_CertImport                                    (CSSM_BASE_CODE        +   9)
#define FNCODE_CSSM_CL_CertSign                                      (CSSM_BASE_CODE        +  10)
#define FNCODE_CSSM_CL_CertUnsign                                    (CSSM_BASE_CODE        +  11)
#define FNCODE_CSSM_CL_CertVerify                                    (CSSM_BASE_CODE        +  12)
#define FNCODE_CSSM_CL_CrlAbortQuery                                 (CSSM_BASE_CODE        +  13)
#define FNCODE_CSSM_CL_CrlAddCert                                    (CSSM_BASE_CODE        +  14)
#define FNCODE_CSSM_CL_CrlCreateTemplate                             (CSSM_BASE_CODE        +  15)
#define FNCODE_CSSM_CL_CrlDescribeFormat                             (CSSM_BASE_CODE        +  16)
#define FNCODE_CSSM_CL_CrlGetFirstFieldValue                         (CSSM_BASE_CODE        +  17)
#define FNCODE_CSSM_CL_CrlGetNextFieldValue                          (CSSM_BASE_CODE        +  18)
#define FNCODE_CSSM_CL_CrlRemoveCert                                 (CSSM_BASE_CODE        +  19)
#define FNCODE_CSSM_CL_CrlSetFields                                  (CSSM_BASE_CODE        +  20)
#define FNCODE_CSSM_CL_CrlSign                                       (CSSM_BASE_CODE        +  21)
#define FNCODE_CSSM_CL_CrlVerify                                     (CSSM_BASE_CODE        +  22)
#define FNCODE_CSSM_CL_IsCertInCrl                                   (CSSM_BASE_CODE        +  23)
#define FNCODE_CSSM_CL_PassThrough                                   (CSSM_BASE_CODE        +  24)
#define FNCODE_CSSM_CSP_ChangeLoginPassword                          (CSSM_BASE_CODE        +  25)
#define FNCODE_CSSM_CSP_CreateAsymmetricContext                      (CSSM_BASE_CODE        +  26)
#define FNCODE_CSSM_CSP_CreateDeriveKeyContext                       (CSSM_BASE_CODE        +  27)
#define FNCODE_CSSM_CSP_CreateDigestContext                          (CSSM_BASE_CODE        +  28)
#define FNCODE_CSSM_CSP_CreateKeyExchContext                         (CSSM_BASE_CODE        +  29)
#define FNCODE_CSSM_CSP_CreateKeyGenContext                          (CSSM_BASE_CODE        +  30)
#define FNCODE_CSSM_CSP_CreateMacContext                             (CSSM_BASE_CODE        +  31)
#define FNCODE_CSSM_CSP_CreatePassThroughContext                     (CSSM_BASE_CODE        +  32)
#define FNCODE_CSSM_CSP_CreateRandomGenContext                       (CSSM_BASE_CODE        +  33)
#define FNCODE_CSSM_CSP_CreateSignatureContext                       (CSSM_BASE_CODE        +  34)
#define FNCODE_CSSM_CSP_CreateSymmetricContext                       (CSSM_BASE_CODE        +  35)
#define FNCODE_CSSM_CSP_CreateUniqueIdContext                        (CSSM_BASE_CODE        +  36)
#define FNCODE_CSSM_CSP_Login                                        (CSSM_BASE_CODE        +  37)
#define FNCODE_CSSM_CSP_Logout                                       (CSSM_BASE_CODE        +  38)
#define FNCODE_CSSM_CSP_PassThrough                                  (CSSM_BASE_CODE        +  39)
#define FNCODE_CSSM_ClearError                                       (CSSM_BASE_CODE        +  40)
#define FNCODE_CSSM_DL_AbortQuery                                    (CSSM_BASE_CODE        +  41)
#define FNCODE_CSSM_DL_Authenticate                                  (CSSM_BASE_CODE        +  42)
#define FNCODE_CSSM_DL_DataDelete                                    (CSSM_BASE_CODE        +  43)
#define FNCODE_CSSM_DL_DataGetFirst                                  (CSSM_BASE_CODE        +  44)
#define FNCODE_CSSM_DL_DataGetNext                                   (CSSM_BASE_CODE        +  45)
#define FNCODE_CSSM_DL_DataInsert                                    (CSSM_BASE_CODE        +  46)
#define FNCODE_CSSM_DL_DbClose                                       (CSSM_BASE_CODE        +  47)
#define FNCODE_CSSM_DL_DbCreate                                      (CSSM_BASE_CODE        +  48)
#define FNCODE_CSSM_DL_DbDelete                                      (CSSM_BASE_CODE        +  49)
#define FNCODE_CSSM_DL_DbExport                                      (CSSM_BASE_CODE        +  50)
#define FNCODE_CSSM_DL_DbGetInfo                                     (CSSM_BASE_CODE        +  51)
#define FNCODE_CSSM_DL_DbGetRecordParsingFunctions                   (CSSM_BASE_CODE        +  52)
#define FNCODE_CSSM_DL_DbImport                                      (CSSM_BASE_CODE        +  53)
#define FNCODE_CSSM_DL_DbOpen                                        (CSSM_BASE_CODE        +  54)
#define FNCODE_CSSM_DL_DbSetInfo                                     (CSSM_BASE_CODE        +  55)
#define FNCODE_CSSM_DL_DbSetRecordParsingFunctions                   (CSSM_BASE_CODE        +  56)
#define FNCODE_CSSM_DL_FreeUniqueRecord                              (CSSM_BASE_CODE        +  57)
#define FNCODE_CSSM_DL_GetDbNameFromHandle                           (CSSM_BASE_CODE        +  58)
#define FNCODE_CSSM_DL_PassThrough                                   (CSSM_BASE_CODE        +  59)
#define FNCODE_CSSM_DecryptData                                      (CSSM_BASE_CODE        +  60)
#define FNCODE_CSSM_DecryptDataFinal                                 (CSSM_BASE_CODE        +  61)
#define FNCODE_CSSM_DecryptDataInit                                  (CSSM_BASE_CODE        +  62)
#define FNCODE_CSSM_DecryptDataUpdate                                (CSSM_BASE_CODE        +  63)
#define FNCODE_CSSM_DeleteContext                                    (CSSM_BASE_CODE        +  64)
#define FNCODE_CSSM_DeleteContextAttributes                          (CSSM_BASE_CODE        +  65)
#define FNCODE_CSSM_DeregisterServices                               (CSSM_BASE_CODE        +  66)
#define FNCODE_CSSM_DeriveKey                                        (CSSM_BASE_CODE        +  67)
#define FNCODE_CSSM_DestroyError                                     (CSSM_BASE_CODE        +  68)
#define FNCODE_CSSM_DigestData                                       (CSSM_BASE_CODE        +  69)
#define FNCODE_CSSM_DigestDataClone                                  (CSSM_BASE_CODE        +  70)
#define FNCODE_CSSM_DigestDataFinal                                  (CSSM_BASE_CODE        +  71)
#define FNCODE_CSSM_DigestDataInit                                   (CSSM_BASE_CODE        +  72)
#define FNCODE_CSSM_DigestDataUpdate                                 (CSSM_BASE_CODE        +  73)
#define FNCODE_CSSM_EncryptData                                      (CSSM_BASE_CODE        +  74)
#define FNCODE_CSSM_EncryptDataFinal                                 (CSSM_BASE_CODE        +  75)
#define FNCODE_CSSM_EncryptDataInit                                  (CSSM_BASE_CODE        +  76)
#define FNCODE_CSSM_EncryptDataUpdate                                (CSSM_BASE_CODE        +  77)
#define FNCODE_CSSM_Free                                             (CSSM_BASE_CODE        +  78)
#define FNCODE_CSSM_FreeContext                                      (CSSM_BASE_CODE        +  79)
#define FNCODE_CSSM_FreeInfo                                         (CSSM_BASE_CODE        +  80)
#define FNCODE_CSSM_FreeList                                         (CSSM_BASE_CODE        +  81)
#define FNCODE_CSSM_FreeModuleInfo                                   (CSSM_BASE_CODE        +  82)
#define FNCODE_CSSM_GenerateAlgorithmParams                          (CSSM_BASE_CODE        +  83)
#define FNCODE_CSSM_GenerateKey                                      (CSSM_BASE_CODE        +  84)
#define FNCODE_CSSM_GenerateKeyPair                                  (CSSM_BASE_CODE        +  85)
#define FNCODE_CSSM_GenerateMac                                      (CSSM_BASE_CODE        +  86)
#define FNCODE_CSSM_GenerateMacFinal                                 (CSSM_BASE_CODE        +  87)
#define FNCODE_CSSM_GenerateMacInit                                  (CSSM_BASE_CODE        +  88)
#define FNCODE_CSSM_GenerateMacUpdate                                (CSSM_BASE_CODE        +  89)
#define FNCODE_CSSM_GenerateRandom                                   (CSSM_BASE_CODE        +  90)
#define FNCODE_CSSM_GetAPIMemoryFunctions                            (CSSM_BASE_CODE        +  91)
#define FNCODE_CSSM_GetCSSMRegistryPath                              (CSSM_BASE_CODE        +  92)
#define FNCODE_CSSM_GetContext                                       (CSSM_BASE_CODE        +  93)
#define FNCODE_CSSM_GetContextAttribute                              (CSSM_BASE_CODE        +  94)
#define FNCODE_CSSM_GetError                                         (CSSM_BASE_CODE        +  95)
#define FNCODE_CSSM_GetGUIDUsage                                     (CSSM_BASE_CODE        +  96)
#define FNCODE_CSSM_GetHandleInfo                                    (CSSM_BASE_CODE        +  97)
#define FNCODE_CSSM_GetHandleUsage                                   (CSSM_BASE_CODE        +  98)
#define FNCODE_CSSM_GetInfo                                          (CSSM_BASE_CODE        +  99)
#define FNCODE_CSSM_GetModuleGUIDFromHandle                          (CSSM_BASE_CODE        + 100)
#define FNCODE_CSSM_GetModuleInfo                                    (CSSM_BASE_CODE        + 101)
#define FNCODE_CSSM_GetModuleLocation                                (CSSM_BASE_CODE        + 102)
#define FNCODE_CSSM_Init                                             (CSSM_BASE_CODE        + 103)
#define FNCODE_CSSM_InitError                                        (CSSM_BASE_CODE        + 104)
#define FNCODE_CSSM_KR_CreateRecoveryEnablementContext               (CSSM_BASE_CODE        + 105)
#define FNCODE_CSSM_KR_CreateRecoveryRegistrationContext             (CSSM_BASE_CODE        + 106)
#define FNCODE_CSSM_KR_CreateRecoveryRequestContext                  (CSSM_BASE_CODE        + 107)
#define FNCODE_CSSM_KR_FreeKRProfile                                 (CSSM_BASE_CODE        + 108)
#define FNCODE_CSSM_KR_GenerateRecoveryFields                        (CSSM_BASE_CODE        + 109)
#define FNCODE_CSSM_KR_GetPolicyInfo                                 (CSSM_BASE_CODE        + 110)
#define FNCODE_CSSM_KR_GetRecoveredObject                            (CSSM_BASE_CODE        + 111)
#define FNCODE_CSSM_KR_ProcessRecoveryFields                         (CSSM_BASE_CODE        + 112)
#define FNCODE_CSSM_KR_RecoveryRequest                               (CSSM_BASE_CODE        + 113)
#define FNCODE_CSSM_KR_RecoveryRequestAbort                          (CSSM_BASE_CODE        + 114)
#define FNCODE_CSSM_KR_RecoveryRetrieve                              (CSSM_BASE_CODE        + 115)
#define FNCODE_CSSM_KR_RegistrationRequest                           (CSSM_BASE_CODE        + 116)
#define FNCODE_CSSM_KR_RegistrationRetrieve                          (CSSM_BASE_CODE        + 117)
#define FNCODE_CSSM_KR_SetEnterpriseRecoveryPolicy                   (CSSM_BASE_CODE        + 118)
#define FNCODE_CSSM_ListModules                                      (CSSM_BASE_CODE        + 119)
#define FNCODE_CSSM_ModuleAttach                                     (CSSM_BASE_CODE        + 120)
#define FNCODE_CSSM_ModuleDetach                                     (CSSM_BASE_CODE        + 121)
#define FNCODE_CSSM_ModuleInstall                                    (CSSM_BASE_CODE        + 122)
#define FNCODE_CSSM_ModuleUninstall                                  (CSSM_BASE_CODE        + 123)
#define FNCODE_CSSM_QueryKeySizeInBits                               (CSSM_BASE_CODE        + 124)
#define FNCODE_CSSM_QuerySize                                        (CSSM_BASE_CODE        + 125)
#define FNCODE_CSSM_RETURN                                           (CSSM_BASE_CODE        + 126)
#define FNCODE_CSSM_RegisterServices                                 (CSSM_BASE_CODE        + 127)
#define FNCODE_CSSM_SetContext                                       (CSSM_BASE_CODE        + 128)
#define FNCODE_CSSM_SetError                                         (CSSM_BASE_CODE        + 129)
#define FNCODE_CSSM_SetModuleInfo                                    (CSSM_BASE_CODE        + 130)
#define FNCODE_CSSM_SignData                                         (CSSM_BASE_CODE        + 131)
#define FNCODE_CSSM_SignDataFinal                                    (CSSM_BASE_CODE        + 132)
#define FNCODE_CSSM_SignDataInit                                     (CSSM_BASE_CODE        + 133)
#define FNCODE_CSSM_SignDataUpdate                                   (CSSM_BASE_CODE        + 134)
#define FNCODE_CSSM_TP_ApplyCrlToDb                                  (CSSM_BASE_CODE        + 135)
#define FNCODE_CSSM_TP_CertGroupConstruct                            (CSSM_BASE_CODE        + 136)
#define FNCODE_CSSM_TP_CertGroupPrune                                (CSSM_BASE_CODE        + 137)
#define FNCODE_CSSM_TP_CertGroupVerify                               (CSSM_BASE_CODE        + 138)
#define FNCODE_CSSM_TP_CertRevoke                                    (CSSM_BASE_CODE        + 139)
#define FNCODE_CSSM_TP_CertSign                                      (CSSM_BASE_CODE        + 140)
#define FNCODE_CSSM_TP_CertVerify                                    (CSSM_BASE_CODE        + 141)
#define FNCODE_CSSM_TP_CrlSign                                       (CSSM_BASE_CODE        + 142)
#define FNCODE_CSSM_TP_CrlVerify                                     (CSSM_BASE_CODE        + 143)
#define FNCODE_CSSM_TP_PassThrough                                   (CSSM_BASE_CODE        + 144)
#define FNCODE_CSSM_UnwrapKey                                        (CSSM_BASE_CODE        + 145)
#define FNCODE_CSSM_UpdateContextAttributes                          (CSSM_BASE_CODE        + 146)
#define FNCODE_CSSM_VerifyComponents                                 (CSSM_BASE_CODE        + 147)
#define FNCODE_CSSM_VerifyData                                       (CSSM_BASE_CODE        + 148)
#define FNCODE_CSSM_VerifyDataFinal                                  (CSSM_BASE_CODE        + 149)
#define FNCODE_CSSM_VerifyDataInit                                   (CSSM_BASE_CODE        + 150)
#define FNCODE_CSSM_VerifyDataUpdate                                 (CSSM_BASE_CODE        + 151)
#define FNCODE_CSSM_VerifyMac                                        (CSSM_BASE_CODE        + 152)
#define FNCODE_CSSM_VerifyMacFinal                                   (CSSM_BASE_CODE        + 153)
#define FNCODE_CSSM_VerifyMacInit                                    (CSSM_BASE_CODE        + 154)
#define FNCODE_CSSM_VerifyMacUpdate                                  (CSSM_BASE_CODE        + 155)
#define FNCODE_CSSM_WrapKey                                          (CSSM_BASE_CODE        + 156)
#define FNCODE_DllMain                                               (CSSM_BASE_CODE        + 157)
#define FNCODE_GUIDcmp                                               (CSSM_BASE_CODE        + 158)
#define FNCODE_ISL_RetrieveRootIssuerKey                             (CSSM_BASE_CODE        + 159)
#define FNCODE_ISL_RetrieveRootIssuerName                            (CSSM_BASE_CODE        + 160)
#define FNCODE_ISL_RetrieveSelfCheckCredentials                      (CSSM_BASE_CODE        + 161)
#define FNCODE_ISL_RetrieveSelfCheckKey                              (CSSM_BASE_CODE        + 162)
#define FNCODE_ISL_RetrieveSelfCheckSectionName                      (CSSM_BASE_CODE        + 163)
#define FNCODE__fini                                                 (CSSM_BASE_CODE        + 164)
#define FNCODE__init                                                 (CSSM_BASE_CODE        + 165)
#define FNCODE_cssm_AddAttribute                                     (CSSM_BASE_CODE        + 166)
#define FNCODE_cssm_AddInDetach                                      (CSSM_BASE_CODE        + 167)
#define FNCODE_cssm_AssignContext                                    (CSSM_BASE_CODE        + 168)
#define FNCODE_cssm_BuildCapabilitiesStruct                          (CSSM_BASE_CODE        + 169)
#define FNCODE_cssm_CheckAPIMemFuncs                                 (CSSM_BASE_CODE        + 170)
#define FNCODE_cssm_CheckContextWithManifestAttributes               (CSSM_BASE_CODE        + 171)
#define FNCODE_cssm_CheckCopy                                        (CSSM_BASE_CODE        + 172)
#define FNCODE_cssm_CheckInit                                        (CSSM_BASE_CODE        + 173)
#define FNCODE_cssm_CheckThreadSafe                                  (CSSM_BASE_CODE        + 174)
#define FNCODE_cssm_ClassToKey                                       (CSSM_BASE_CODE        + 175)
#define FNCODE_cssm_CleanUp                                          (CSSM_BASE_CODE        + 176)
#define FNCODE_cssm_CopyCertChainList                                (CSSM_BASE_CODE        + 177)
#define FNCODE_cssm_CopyCryptoDataStruct                             (CSSM_BASE_CODE        + 178)
#define FNCODE_cssm_CopyDataStruct                                   (CSSM_BASE_CODE        + 179)
#define FNCODE_cssm_CopyDateStruct                                   (CSSM_BASE_CODE        + 180)
#define FNCODE_cssm_CopyKRProfileDataStruct                          (CSSM_BASE_CODE        + 181)
#define FNCODE_cssm_CopyKeyStruct                                    (CSSM_BASE_CODE        + 182)
#define FNCODE_cssm_CopyRangeStruct                                  (CSSM_BASE_CODE        + 183)
#define FNCODE_cssm_CreateAttribute                                  (CSSM_BASE_CODE        + 184)
#define FNCODE_cssm_CreateContext                                    (CSSM_BASE_CODE        + 185)
#define FNCODE_cssm_DaysExpire                                       (CSSM_BASE_CODE        + 186)
#define FNCODE_cssm_DelContextAttr                                   (CSSM_BASE_CODE        + 187)
#define FNCODE_cssm_DeleteModuleRecord                               (CSSM_BASE_CODE        + 188)
#define FNCODE_cssm_DuplicateAttributes                              (CSSM_BASE_CODE        + 189)
#define FNCODE_cssm_DuplicateContext                                 (CSSM_BASE_CODE        + 190)
#define FNCODE_cssm_Expire                                           (CSSM_BASE_CODE        + 191)
#define FNCODE_cssm_FindCSPHandle                                    (CSSM_BASE_CODE        + 192)
#define FNCODE_cssm_FindMemory                                       (CSSM_BASE_CODE        + 193)
#define FNCODE_cssm_FreeAttributes                                   (CSSM_BASE_CODE        + 194)
#define FNCODE_cssm_FreeCLSubService                                 (CSSM_BASE_CODE        + 195)
#define FNCODE_cssm_FreeCLWrapped                                    (CSSM_BASE_CODE        + 196)
#define FNCODE_cssm_FreeCSPSubService                                (CSSM_BASE_CODE        + 197)
#define FNCODE_cssm_FreeCSPWrapped                                   (CSSM_BASE_CODE        + 198)
#define FNCODE_cssm_FreeCertChain                                    (CSSM_BASE_CODE        + 199)
#define FNCODE_cssm_FreeCertChainList                                (CSSM_BASE_CODE        + 200)
#define FNCODE_cssm_FreeContext                                      (CSSM_BASE_CODE        + 201)
#define FNCODE_cssm_FreeDLSubService                                 (CSSM_BASE_CODE        + 202)
#define FNCODE_cssm_FreeData                                         (CSSM_BASE_CODE        + 203)
#define FNCODE_cssm_FreeDbAttributeInfo                              (CSSM_BASE_CODE        + 204)
#define FNCODE_cssm_FreeDbInfo                                       (CSSM_BASE_CODE        + 205)
#define FNCODE_cssm_FreeHardwareInfo                                 (CSSM_BASE_CODE        + 206)
#define FNCODE_cssm_FreeIntContext                                   (CSSM_BASE_CODE        + 207)
#define FNCODE_cssm_FreeKRName                                       (CSSM_BASE_CODE        + 208)
#define FNCODE_cssm_FreeKRProfile                                    (CSSM_BASE_CODE        + 209)
#define FNCODE_cssm_FreeKRSPInfo                                     (CSSM_BASE_CODE        + 210)
#define FNCODE_cssm_FreeKRSPSubService                               (CSSM_BASE_CODE        + 211)
#define FNCODE_cssm_FreeModule                                       (CSSM_BASE_CODE        + 212)
#define FNCODE_cssm_FreeSWInfo                                       (CSSM_BASE_CODE        + 213)
#define FNCODE_cssm_FreeString                                       (CSSM_BASE_CODE        + 214)
#define FNCODE_cssm_FreeTPSubService                                 (CSSM_BASE_CODE        + 215)
#define FNCODE_cssm_GUIDToStr                                        (CSSM_BASE_CODE        + 216)
#define FNCODE_cssm_GenerateCredentialPathAndSection                 (CSSM_BASE_CODE        + 217)
#define FNCODE_cssm_GetAddInCallBackByHandle                         (CSSM_BASE_CODE        + 218)
#define FNCODE_cssm_GetAlgCount                                      (CSSM_BASE_CODE        + 219)
#define FNCODE_cssm_GetAttributeFromContext                          (CSSM_BASE_CODE        + 220)
#define FNCODE_cssm_GetCSPContext                                    (CSSM_BASE_CODE        + 221)
#define FNCODE_cssm_GetContextFromManifestAttrib                     (CSSM_BASE_CODE        + 222)
#define FNCODE_cssm_GetGUIDFromHandle                                (CSSM_BASE_CODE        + 223)
#define FNCODE_cssm_GetHandleInfo                                    (CSSM_BASE_CODE        + 224)
#define FNCODE_cssm_GetMemory                                        (CSSM_BASE_CODE        + 225)
#define FNCODE_cssm_GetModuleByHandle                                (CSSM_BASE_CODE        + 226)
#define FNCODE_cssm_GetModuleCallBackByHandle                        (CSSM_BASE_CODE        + 227)
#define FNCODE_cssm_GetModuleRecordByGUID                            (CSSM_BASE_CODE        + 228)
#define FNCODE_cssm_GetMultitaskMutexHandle                          (CSSM_BASE_CODE        + 229)
#define FNCODE_cssm_GetSelfCheckKeyBlock                             (CSSM_BASE_CODE        + 230)
#define FNCODE_cssm_GetUsageMask                                     (CSSM_BASE_CODE        + 231)
#define FNCODE_cssm_HasIntAttrValueInContext                         (CSSM_BASE_CODE        + 232)
#define FNCODE_cssm_IncrementAddInAppMemory                          (CSSM_BASE_CODE        + 233)
#define FNCODE_cssm_IncrementAlgCount                                (CSSM_BASE_CODE        + 234)
#define FNCODE_cssm_InsertContext                                    (CSSM_BASE_CODE        + 235)
#define FNCODE_cssm_IsAdminUser                                      (CSSM_BASE_CODE        + 236)
#define FNCODE_cssm_IsBadCryptoDataPtr                               (CSSM_BASE_CODE        + 237)
#define FNCODE_cssm_IsBadCryptoKeyPtr                                (CSSM_BASE_CODE        + 238)
#define FNCODE_cssm_IsValidCSP                                       (CSSM_BASE_CODE        + 239)
#define FNCODE_cssm_KR_ApplyENTPolicy                                (CSSM_BASE_CODE        + 240)
#define FNCODE_cssm_KR_ApplyLEPolicy                                 (CSSM_BASE_CODE        + 241)
#define FNCODE_cssm_KR_ApplyPolicy                                   (CSSM_BASE_CODE        + 242)
#define FNCODE_cssm_KR_GetEnterpriseKRPolicySecret                   (CSSM_BASE_CODE        + 243)
#define FNCODE_cssm_KR_IsCryptoPermitted                             (CSSM_BASE_CODE        + 244)
#define FNCODE_cssm_KR_PolicyDelete                                  (CSSM_BASE_CODE        + 245)
#define FNCODE_cssm_KR_PolicyInit                                    (CSSM_BASE_CODE        + 246)
#define FNCODE_cssm_KR_Policy_Add                                    (CSSM_BASE_CODE        + 247)
#define FNCODE_cssm_KR_Policy_Item_Fill                              (CSSM_BASE_CODE        + 248)
#define FNCODE_cssm_KR_Policy_Lookup                                 (CSSM_BASE_CODE        + 249)
#define FNCODE_cssm_KR_Policy_Lookup_Specific                        (CSSM_BASE_CODE        + 250)
#define FNCODE_cssm_KR_RegReadEnterpriseRecoveryPolicy               (CSSM_BASE_CODE        + 251)
#define FNCODE_cssm_KR_RegWriteEnterpriseRecoveryPolicy              (CSSM_BASE_CODE        + 252)
#define FNCODE_cssm_KR_SetContextPriv                                (CSSM_BASE_CODE        + 253)
#define FNCODE_cssm_KeyToClassMask                                   (CSSM_BASE_CODE        + 254)
#define FNCODE_cssm_ModuleAttach                                     (CSSM_BASE_CODE        + 255)
#define FNCODE_cssm_ModuleInstall                                    (CSSM_BASE_CODE        + 256)
#define FNCODE_cssm_ModuleUninstall                                  (CSSM_BASE_CODE        + 257)
#define FNCODE_cssm_NewModuleRecord                                  (CSSM_BASE_CODE        + 258)
#define FNCODE_cssm_Rand                                             (CSSM_BASE_CODE        + 259)
#define FNCODE_cssm_RegReadCSPWrapped                                (CSSM_BASE_CODE        + 260)
#define FNCODE_cssm_RegReadField                                     (CSSM_BASE_CODE        + 261)
#define FNCODE_cssm_ReadManifest                                     (CSSM_BASE_CODE        + 262)
#define FNCODE_cssm_RegAddinIsDynamic                                (CSSM_BASE_CODE        + 263)
#define FNCODE_cssm_RegCountCSPAlgorithms                            (CSSM_BASE_CODE        + 264)
#define FNCODE_cssm_RegFindServiceNum                                (CSSM_BASE_CODE        + 265)
#define FNCODE_cssm_RegFindSubServiceNum                             (CSSM_BASE_CODE        + 266)
#define FNCODE_cssm_RegGetLocation                                   (CSSM_BASE_CODE        + 267)
#define FNCODE_cssm_RegReadAllContext                                (CSSM_BASE_CODE        + 268)
#define FNCODE_cssm_RegReadBinary                                    (CSSM_BASE_CODE        + 269)
#define FNCODE_cssm_RegReadCLSubService                              (CSSM_BASE_CODE        + 270)
#define FNCODE_cssm_RegReadCLWrapped                                 (CSSM_BASE_CODE        + 271)
#define FNCODE_cssm_RegReadCSPCapList                                (CSSM_BASE_CODE        + 272)
#define FNCODE_cssm_RegReadCSPHardwareService                        (CSSM_BASE_CODE        + 273)
#define FNCODE_cssm_RegReadCSPList                                   (CSSM_BASE_CODE        + 274)
#define FNCODE_cssm_RegReadCSPSWService                              (CSSM_BASE_CODE        + 275)
#define FNCODE_cssm_RegReadCSPServiceClasses                         (CSSM_BASE_CODE        + 276)
#define FNCODE_cssm_RegReadCSPSubService                             (CSSM_BASE_CODE        + 277)
#define FNCODE_cssm_RegReadCSSMInfo                                  (CSSM_BASE_CODE        + 278)
#define FNCODE_cssm_RegReadCSSMString                                (CSSM_BASE_CODE        + 279)
#define FNCODE_cssm_RegReadCommonModuleInfo                          (CSSM_BASE_CODE        + 280)
#define FNCODE_cssm_RegReadContext                                   (CSSM_BASE_CODE        + 281)
#define FNCODE_cssm_RegReadContextAttrib                             (CSSM_BASE_CODE        + 282)
#define FNCODE_cssm_RegReadContextAttribKeyType                      (CSSM_BASE_CODE        + 283)
#define FNCODE_cssm_RegReadDLDBAttributeInfo                         (CSSM_BASE_CODE        + 284)
#define FNCODE_cssm_RegReadDLDBRecordAttribute                       (CSSM_BASE_CODE        + 285)
#define FNCODE_cssm_RegReadDLDBRecordIndex                           (CSSM_BASE_CODE        + 286)
#define FNCODE_cssm_RegReadDLDataStoreInfo                           (CSSM_BASE_CODE        + 287)
#define FNCODE_cssm_RegReadDLDataStoreName                           (CSSM_BASE_CODE        + 288)
#define FNCODE_cssm_RegReadDLSubService                              (CSSM_BASE_CODE        + 289)
#define FNCODE_cssm_RegReadDLWrapped                                 (CSSM_BASE_CODE        + 290)
#define FNCODE_cssm_RegReadDataStruct                                (CSSM_BASE_CODE        + 291)
#define FNCODE_cssm_RegReadKRSPInfo                                  (CSSM_BASE_CODE        + 292)
#define FNCODE_cssm_RegReadKRSPSubService                            (CSSM_BASE_CODE        + 293)
#define FNCODE_cssm_RegReadKRWrapped                                 (CSSM_BASE_CODE        + 294)
#define FNCODE_cssm_RegReadModuleInfo                                (CSSM_BASE_CODE        + 295)
#define FNCODE_cssm_RegReadModuleList                                (CSSM_BASE_CODE        + 296)
#define FNCODE_cssm_RegReadService                                   (CSSM_BASE_CODE        + 297)
#define FNCODE_cssm_RegReadString                                    (CSSM_BASE_CODE        + 298)
#define FNCODE_cssm_RegReadTPSubService                              (CSSM_BASE_CODE        + 299)
#define FNCODE_cssm_RegReadTPWrapped                                 (CSSM_BASE_CODE        + 300)
#define FNCODE_cssm_RegReadUTC                                       (CSSM_BASE_CODE        + 301)
#define FNCODE_cssm_RegReadUsage                                     (CSSM_BASE_CODE        + 302)
#define FNCODE_cssm_RegReadVersion                                   (CSSM_BASE_CODE        + 303)
#define FNCODE_cssm_RegRemoveModule                                  (CSSM_BASE_CODE        + 304)
#define FNCODE_cssm_RegWriteCLSubService                             (CSSM_BASE_CODE        + 305)
#define FNCODE_cssm_RegWriteCLWrapped                                (CSSM_BASE_CODE        + 306)
#define FNCODE_cssm_RegWriteCSPCapList                               (CSSM_BASE_CODE        + 307)
#define FNCODE_cssm_RegWriteCSPHardwareService                       (CSSM_BASE_CODE        + 308)
#define FNCODE_cssm_RegWriteCSPSWService                             (CSSM_BASE_CODE        + 309)
#define FNCODE_cssm_RegWriteCSPSubService                            (CSSM_BASE_CODE        + 310)
#define FNCODE_cssm_RegWriteCSPWrapped                               (CSSM_BASE_CODE        + 311)
#define FNCODE_cssm_RegWriteCSSMInfo                                 (CSSM_BASE_CODE        + 312)
#define FNCODE_cssm_RegWriteCSSMString                               (CSSM_BASE_CODE        + 313)
#define FNCODE_cssm_RegWriteCommonInfo                               (CSSM_BASE_CODE        + 314)
#define FNCODE_cssm_RegWriteContext                                  (CSSM_BASE_CODE        + 315)
#define FNCODE_cssm_RegWriteContextAttrib                            (CSSM_BASE_CODE        + 316)
#define FNCODE_cssm_RegWriteDLDBAttributeInfo                        (CSSM_BASE_CODE        + 317)
#define FNCODE_cssm_RegWriteDLDBRecordAttribute                      (CSSM_BASE_CODE        + 318)
#define FNCODE_cssm_RegWriteDLDBRecordIndex                          (CSSM_BASE_CODE        + 319)
#define FNCODE_cssm_RegWriteDLDataStoreInfo                          (CSSM_BASE_CODE        + 320)
#define FNCODE_cssm_RegWriteDLDataStoreName                          (CSSM_BASE_CODE        + 321)
#define FNCODE_cssm_RegWriteDLSubService                             (CSSM_BASE_CODE        + 322)
#define FNCODE_cssm_RegWriteDLWrapped                                (CSSM_BASE_CODE        + 323)
#define FNCODE_cssm_RegWriteDataStruct                               (CSSM_BASE_CODE        + 324)
#define FNCODE_cssm_RegWriteKRSPInfo                                 (CSSM_BASE_CODE        + 325)
#define FNCODE_cssm_RegWriteKRSPSubService                           (CSSM_BASE_CODE        + 326)
#define FNCODE_cssm_RegWriteKRWrapped                                (CSSM_BASE_CODE        + 327)
#define FNCODE_cssm_RegWriteModule                                   (CSSM_BASE_CODE        + 328)
#define FNCODE_cssm_RegWriteModuleInfo                               (CSSM_BASE_CODE        + 329)
#define FNCODE_cssm_RegWriteString                                   (CSSM_BASE_CODE        + 330)
#define FNCODE_cssm_RegWriteTPSubService                             (CSSM_BASE_CODE        + 331)
#define FNCODE_cssm_RegWriteTPWrapped                                (CSSM_BASE_CODE        + 332)
#define FNCODE_cssm_RegWriteVersion                                  (CSSM_BASE_CODE        + 333)
#define FNCODE_cssm_RemoveAddInRecord                                (CSSM_BASE_CODE        + 334)
#define FNCODE_cssm_SaveContextClone                                 (CSSM_BASE_CODE        + 335)
#define FNCODE_cssm_SpiCalloc                                        (CSSM_BASE_CODE        + 336)
#define FNCODE_cssm_SpiFree                                          (CSSM_BASE_CODE        + 337)
#define FNCODE_cssm_SpiMalloc                                        (CSSM_BASE_CODE        + 338)
#define FNCODE_cssm_SpiRealloc                                       (CSSM_BASE_CODE        + 339)
#define FNCODE_cssm_StrToGUID                                        (CSSM_BASE_CODE        + 340)
#define FNCODE_cssm_UpdateAttribute                                  (CSSM_BASE_CODE        + 341)
#define FNCODE_cssm_UpdateContext                                    (CSSM_BASE_CODE        + 342)
#define FNCODE_cssm_ValidateAttributeValue                           (CSSM_BASE_CODE        + 343)
#define FNCODE_cssm_ValidateContextValue                             (CSSM_BASE_CODE        + 344)
#define FNCODE_cssm_RegWriteBinary                                   (CSSM_BASE_CODE        + 345)
#define FNCODE_cssm_RegWriteFields                                   (CSSM_BASE_CODE        + 346)
#define FNCODE_cssm_RegWriteUTC                                      (CSSM_BASE_CODE        + 347)
#define FNCODE_cssm_dynamic_getinfo                                  (CSSM_BASE_CODE        + 348)
#define FNCODE_cssm_IsValidAddInHandle                               (CSSM_BASE_CODE        + 349)
#define FNCODE_cssm_AddinLoad                                        (CSSM_BASE_CODE        + 350)
#define FNCODE_cssm_GetTimeValue                                     (CSSM_BASE_CODE        + 351)
#define FNCODE_cssm_GetOperationalStatistics                         (CSSM_BASE_CODE        + 352)
#define CSSM_BASE_CODE 0

#define FILTER_CSSM "cssm"

#ifndef BINARY_TRACE
extern char* cssm_function_names[];
typedef struct {char *filter; char **function_names;} TraceInfo;
extern TraceInfo cssm_trace_info;
#else
#define cssm_trace_info FILTER_CSSM
#endif /* BINARY_TRACE */

#endif /* _CSSM_CODEFILE_H */

#endif /* DO_TRACE */
