/*-----------------------------------------------------------------------
 * File: MDS_SHIM.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "cssm.h"
#include "emmtype.h"
#include "cssmapi.h"
#include "cssmdli.h"
#include "mds.h"
#include "mds_schema.h"
#include "mds_util_type.h"

#ifndef MDS_SHIM_H
#define MDS_SHIM_H

#ifdef __cplusplus
extern "C" {
#endif

#define RETURN_EXPRESSION(x) return(x);

MDS_FUNCS MdsFuncs;

CSSM_DB_ATTRIBUTE_DATA s_ObjectAttributes[MDS_OBJECT_NUM_ATTRIBUTES];
CSSM_DB_ATTRIBUTE_DATA s_cssmAttributes[MDS_CDSADIR_CSSM_NUM_ATTRIBUTES];

typedef enum mds_module_type {
    MDS_CSSM = 0,
    MDS_ADDIN = 1,
    MDS_APPLICATION = 2,
    MDS_MODULE_MANAGER = 3
} MDS_MODULE_TYPE;

typedef struct mds_info {
    MDS_MODULE_TYPE   Type;
    union {
        MDSUTIL_APP_SERVICE_INFO    app_info;
        MDSUTIL_MODULE_INFO         module_info;
        MDSUTIL_MODULE_MANAGER_INFO module_manager_info;
    }mds_module_info;
}MDS_INFO, *MDS_INFO_PTR;

typedef struct mds_object_record {
    CSSM_DATA guid;
    CSSM_DATA Manifest;
    CSSM_DATA ModuleName;
    CSSM_DATA Path;
} MDS_OBJECT_RECORD, *MDS_OBJECT_RECORD_PTR;

CSSM_RETURN
MDS_RegisterModule( CSSM_GUID Guid,
                    const char *ModuleRoot,
                    const char *ModuleExt,
                    const char *ModulePath,
                    const char *ManifestPath,
                    MDS_MODULE_TYPE ModuleType );


CSSM_RETURN
MDS_DeRegisterModule( CSSM_GUID Guid,
                      MDS_MODULE_TYPE ModuleType );

#ifdef __cplusplus
}
#endif                             

#endif /* MDS_SHIM_H */
