/*-----------------------------------------------------------------------
 * File: SPKI_OID.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#if !defined(_SPKI_OID_H_)
#define _SPKI_OID_H_

#include "cssmtype.h"

#define NUMBER_SPKI_CERT_OIDS  (4)

typedef struct spki_oid_int {
	CSSM_OID_PTR oidval;
	uint32	     intval;
} SPKI_OID_INT;

extern SPKI_OID_INT SPKI_CERT_OIDS[NUMBER_SPKI_CERT_OIDS];

extern CSSM_OID SPKI_PACKED_CERT_OID,
                SPKI_PARSED_CERT_OID,
				SPKI_PACKED_PUBLIC_KEY_OID,
				SPKI_PACKED_HASH_OID;

typedef enum intel_spki_oid_as_int {
    INT_NoMatch = 0,

    INT_SPKIPackedCert,
    INT_SPKIParsedCert,
    INT_SPKIPackedPublicKey,
    INT_SPKIPackedHash
} INTEL_SPKI_OID_AS_INT;

#endif /* _SPKI_OID_H_ */

