/*-----------------------------------------------------------------------
 * File: HRS.H
 *
 * Copyright (c) 2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* 
 * Basic include file for all HRS headers. Behavior of the file can be
 * modified by specifying pre-processor symbols prior to including the
 * header.
 *
 * Identifier       Result
 * ----------       ------
 * NO_HRS_SPI       The types and functions for the HRS SPI are not
 *                  included.
 */

#ifndef _HRS_H_
#define _HRS_H_


/* Version information */
/* Version 0.7.0.X */
#define HRS_VERSION_MAJOR 0 /* Major version # */
#define HRS_VERSION_MINOR 7 /* Minor version # */

/* All data types defined by the HRS API specification */
#include "cssmtype.h"
#include "hrstype.h"

/* All APIs defined by the HRS API specification.
 */
#include "cssmhrs.h"

/* Error code definitions used in the CSSM specification. */
#include "hrserr.h"

#if !defined(NO_HRS_SPI)
/* Data types and function declarations for the common interfaces
 * that must be implemented by a CDSA service provider.
 */
#include "cssmspi.h"

/* Interfaces that must be implemented by a Human Recognition Service
 * (HRS) SPI.
 */
#include "cssmhrsi.h"

#endif /* !defined(NO_CSSM_SPI) */


#endif /* ifndef _HRS_H_ */
