/*-----------------------------------------------------------------------
 * File: COMPARE.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* Module name: compare.c
   Compares two DSAData integers. The return value is
   -1     a < b
   0      a == b
   1      a > b

   DSAData numbers are assumed to be normalized, i.e. the most significand
   word is not zero.
*/

#include "eicl.h"
#include "dss.h"

int __stdcall EICL_Compare (DSAData *a, DSAData *b)
{
  register long	alen, blen;

  alen=a->length;
  blen=b->length;
  if (alen > blen) return 1;
  if (alen < blen) return -1;
  while (alen-->0) {
    if (a->value[alen] > b->value[alen]) return 1;
    if (a->value[alen] < b->value[alen]) return -1;
  }
  return 0;
}
