/*-----------------------------------------------------------------------
 * File: MODMUL.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* Module name: modmul.c
   Computes t = a * b mod n
*/

#include "eicl.h"
#include "dss.h"


void __stdcall EICL_ModMul (DSAData *a, DSAData *b, DSAData *n, DSAData *t)
{
  register int	cnt, k;
  EICLWord	*bval, bi, bitmask;
  EICLWord	uarray[MODULUS+1];
  DSAData	u;

/* u = 0 */
    u.length = 1;
    u.value = uarray;
    for (cnt=MODULUS; cnt>=0; --cnt)
        uarray[cnt] = 0;
    bval = b->value;

/* start the main loop */
    for (cnt=b->length-1; cnt>=0; --cnt) {
        bi = bval[cnt];
        for (bitmask=(EICLWord)1<<(WORDSIZE-1); bitmask!=0; bitmask>>=1) {
/* shl u,1 */
            uarray[u.length] = 0;
            for (k=u.length-1; k>=0; --k) {
                uarray[k+1] |= uarray[k] >> (WORDSIZE-1);
                uarray[k] <<= 1;
            }
            if (uarray[u.length])   ++u.length;

/* if u>=n then u = u - n */
            if (EICL_Compare (&u, n)>=0)
                EICL_Subtract (&u, n);

/* u = u+bi*a */
            if (bitmask & bi) {
                EICL_Add (&u, a, &u);
                while (u.length>1 && uarray[u.length-1]==0)
                    --u.length;
            }
/* if u>=n then u = u - n */
            if (EICL_Compare (&u, n)>=0)
                EICL_Subtract (&u, n);
        }
    }

/* copy u to t and adjust length */
    bval = t->value;
    for (cnt=u.length; cnt>=0; --cnt)
        bval[cnt] = uarray[cnt];
    for (cnt=u.length-1; bval[cnt]==0; --cnt) ;
    t->length = cnt+1;
}
