/*-----------------------------------------------------------------------
 * File: N0PRIME.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* Module name: n0prime.c
   Computes n0' for Montgomery product.
*/

#include "eicl.h"
#include "dss.h"

EICLWord __stdcall N0Prime (EICLWord n0)
{
  register int		i;
  register EICLWord	A, B, C;
  long			n0pr;

  n0pr = 1;
  A = 0x00000001 << 1;
  B = 0x00000003;
  C = B & n0;
  for (i=2; i<1+8*sizeof(EICLWord); i++) {
    if (A < C) n0pr+=A;
    A = A << 1;
    B = (B << 1) | 0x00000001;
    C = n0*n0pr & B;
  }
  return (~n0pr + 1);
}
