/*-----------------------------------------------------------------------
 * File: BYTES.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/*	Module name: bytes.c
	Byte/Word related functions.
*/

#include "eicl.h"
#include "dss.h"
#include "eiclproc.h"

/* pads the given structures unused high words with 0's to upto MODULUS words */
void __stdcall EICL_Padding0 (DSAData *a)
{
	long	cnt;
	EICLWord	*aval;

	cnt = a->length;
	aval = &a->value[cnt];
	while (cnt++<MODULUS)
	  *(aval++) = 0;
}


/* pads the excess bytes of DSSData whose size is "ByteLength" bytes.
   DSAData.length is not modified.
*/
void __stdcall	EICL_PadBytes0 (DSAData *a, long ByteLength)
{
	EICLWord	*aval;

	aval = &a->value[EICL_WordCount (ByteLength)];
/* Word.length */
	ByteLength = (sizeof (EICLWord) - (ByteLength & 0x03)) * 8;	/* 32, 24, 26, 8 */
/* if the last word is not fully used, strip off the excess bytes */
	if (ByteLength<32)
	  *aval = *aval & ( (~(EICLWord)0) >> ByteLength );
}


/* the exact number of bytes to store this word-aligned data */
int __stdcall EICL_ByteCount (DSAData *a)
{
	register long	length;
	EICLWord			sval;

/* the base length. Note that, a->length is word.length */
	length = (a->length-1) * sizeof (EICLWord);
	sval = a->value[a->length-1];
/* if there are excess bytes, then add them to the base length */
	if (sval & 0xFF000000)		length += 4;
	else if (sval & 0x00FF0000)	length += 3;
	else if (sval & 0x0000FF00)	length += 2;
	else if (sval & 0x000000FF)	length += 1;
	return length;
}
