/*-----------------------------------------------------------------------
 * File: DSSKG.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* Module name: dsakg.h
   Header file for DSA Key Generation routines and variables
*/

#if !defined(EICL_DSAKG_INCLUDE)
#define EICL_DSAKG_INCLUDE	1


/* Maximum number of bases to use in weak primality test */
#define	MAXNUMBEROFBASES                64

/* The small prime list to be used in trial division step */
extern EICLWord	PrimeList[];

#ifdef __cplusplus
extern "C" {
#endif

int __stdcall	EICL_TrialDivision
					(DSAData	*PseudoPrime);

int __stdcall	EICL_WeakPseudoPrimality
					(DSAData	*PseudoPrime,
 					 int		Count);

void __stdcall	EICL_NextOdd
					(DSAData	*Odd);

void __stdcall	EICL_ModularInverse
					(EICLData	*Number,
					EICLData		*Modulus,
					EICLData		*Inverse);

void __stdcall	EICL_EEA
					(DSAData	*a,
 					DSAData		*b,
				 	DSAData		*vpp,
 					DSAData		*upp,
 					DSAData		*rpp,
 					int			*k);

void __stdcall	EICL_Div
					(DSAData	*Dividend,
					DSAData		*Divisor,
					DSAData		*Divide);

void __stdcall	EICL_GCD
					(DSAData	*a,
					DSAData		*b,
					DSAData		*gcd);

int __stdcall	EICL_FindPrime
					(DSAData	*PseudoPrime);

void __stdcall	EICL_FindPublicExponent
					(DSAData	*PublicExpCandidate,
					DSAData		*PhiN);

int __stdcall	DSA_Remainder
					(DSAData	*a,
					EICLWord     b);

#ifdef __cplusplus
}
#endif

#endif

