/*-----------------------------------------------------------------------
 * File: BER_BN.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/*
 * This is the header file for some Basic Encoding Rules and Distinguished
 * Encoding Rules (BER/DER) routines.
 */

#ifndef BER_BN_H
#define BER_BN_H
#include <stdlib.h>
#include "eicl.h"
#include "ber_der.h"
/*
 * The declarations for these functions need to precede their
 * #pragma intrinsic directives.  They already do on WIN32 because
 * windows.h is included before us and it includes string.h.
 * Including string.h here covers UNIX and does no harm on WIN32. 
 *
 * The reason the declarations need to come first is that some
 * compilers (like the DEC C compiler) ignore the #pragma intrinsic
 * directives otherwise.
 */
#include <string.h>
#ifndef VMS
#pragma intrinsic(memcmp)
#endif
#pragma intrinsic(memcpy)
#pragma intrinsic(memset)
#pragma intrinsic(strlen)
#pragma intrinsic(strcpy)

/* DER-encode an array of ICL numbers */
uint32 
DER_Encode(const EICLData *DataBufs, 
	sint16 DataBufCount,
	uint8 *Octets);
/* convert a sequence of BER encoded integers to an array of ICL numbers */
sint16 
BER_Decode(uint8 *Octets, 
	uint32 OctetCount, 
	EICLData *DataBufs,
	sint16 DataBufCount);
int 
BER_BerToVeryUnLong(const unsigned char *octets, void *bignum, int maxCount);
/*	
 * encode "Count" bytes of a bignum into a DER integer at the 
 * given memory, return length in octets 
 */
size_t 
DER_VeryUnLongToDer(
	void *bignum,			/* the number in native byte sex format */
	int Count,				/* size of array in bytes */
	unsigned char *octets);	/* target for DER output */

#endif /* BER_BN_H */
