/*-----------------------------------------------------------------------
 * File: MUTTAGS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* values for distinguishing tag types */
#define LOOP         0xf0
#define PROC         0xf1
#define MUTATE_POINT 0xf2

/* three bytes of illegal opcodes so we can be sure the code we're
 * looking at is a tag
 */
#define TAGLEN 0x8
#define TAG0   0xd6
#define TAG1   0xf1
#define TAG2   0xf4

#ifdef WIN32
#define NAMECODE(T,W,X,Y,Z) \
__asm { __asm _emit 0xeb __asm _emit TAGLEN \
__asm _emit TAG0 __asm _emit TAG1 __asm _emit TAG2 \
__asm _emit (T) \
__asm _emit (Z) \
__asm _emit (Y) \
__asm _emit (X) \
__asm _emit (W) \
__asm _emit 0x90 }
#else
#define NAMECODE(T,W,X,Y,Z)
#endif

#define NAMELOOP(W,X,Y,Z)     NAMECODE(LOOP,(W),(X),(Y),(Z))
#define NAMEPROC(W,X,Y,Z)     NAMECODE(PROC,(W),(X),(Y),(Z))
#define NAMEMUT(W,X,Y,Z)      NAMECODE(MUTATE_POINT,(W),(X),(Y),(Z))
