// 
// @DEC_COPYRIGHT@
//
// HISTORY
// $Log: memfx.cpp,v $
// Revision 1.1.2.4  2000/08/31  18:08:33  Thomas_Woodburn
// 	Merged in Intel CDSA Version 2.0 Release 3.11.
//
// Revision 1.1.2.3  2000/08/07  14:44:16  Thomas_Woodburn
// 	Merged in Intel CDSA Version 2.0 Release 3.1.
//
// Revision 1.1.2.2  2000/06/28  21:00:39  Thomas_Woodburn
// 	Initial port to Tru64 UNIX.
//
// Revision 1.1.2.1  2000/06/28  20:27:52  Thomas_Woodburn
// 	Created from Intel CDSA Version 2.0 Release 3.0.
//
// $EndLog$
// 
#ifndef WIN32
#ifndef VMS
#pragma ident "@(#)$RCSfile: memfx.cpp,v $ $Revision: 1.1.2.4 $ (DEC) $Date: 2000/08/31 18:08:33 $"
#endif
#endif

#ifndef VMS
#include <malloc.h>
#endif

#include <cssm.h>
#ifdef COMPAQ_FIX
#include <stdlib.h>		/* calloc(), free(), malloc(), realloc() */
#endif /* COMPAQ_FIX */

#include "memfx.h"



void* CSSMAPI
_app_malloc(uint32 size,
           void *palloc_ref
#ifdef CSSM_MEMTRACK_ON
		   , const char *szFilename,
		   uint32 u32LineNumber
#endif
			)
{
#if defined(_DEBUG) && defined(CSSM_MEMTRACK_ON) && defined(WIN32)
		return _malloc_dbg( size, _NORMAL_BLOCK, szFilename, u32LineNumber );
#else
		return malloc( size );
#endif
}

void* CSSMAPI
_app_calloc(uint32 num_elements,
           uint32 size_element,
           void *palloc_ref
#ifdef CSSM_MEMTRACK_ON
		   , const char *szFilename,
		   uint32 u32LineNumber
#endif
		   )
{
#if defined(_DEBUG) && defined(CSSM_MEMTRACK_ON) && defined(WIN32)
	return _calloc_dbg( num_elements, size_element, _NORMAL_BLOCK, szFilename, u32LineNumber );
#else
	return calloc(num_elements, size_element );
#endif
}


void* CSSMAPI
_app_realloc(void * ptr,
            uint32 new_size,
            void *palloc_ref
#ifdef CSSM_MEMTRACK_ON
			, const char *szFilename,
			uint32 u32LineNumber
#endif
			)
{
#if defined(_DEBUG) && defined(CSSM_MEMTRACK_ON) && defined(WIN32)
	return _realloc_dbg( ptr, new_size, _NORMAL_BLOCK, szFilename, u32LineNumber );
#else
	return realloc(ptr, new_size);
#endif
}

void CSSMAPI
_app_free(void * ptr,
         void *palloc_ref
#ifdef CSSM_MEMTRACK_ON
		 , const char *szFilename,
		 uint32 u32LineNumber
#endif
		 )
{
#if defined(_DEBUG) && defined(CSSM_MEMTRACK_ON) && defined(WIN32)
	_free_dbg( ptr, _NORMAL_BLOCK );
#else
	free(ptr);
#endif
	//return;
}
