/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: mrm_defs.h,v $
 * Revision 1.1.2.4  2000/08/31  18:09:07  Thomas_Woodburn
 * 	Merged in Intel CDSA Version 2.0 Release 3.11.
 *
 * Revision 1.1.2.3  2000/08/07  14:44:51  Thomas_Woodburn
 * 	Merged in Intel CDSA Version 2.0 Release 3.1.
 *
 * Revision 1.1.2.2  2000/06/28  21:00:46  Thomas_Woodburn
 * 	Initial port to Tru64 UNIX.
 *
 * Revision 1.1.2.1  2000/06/28  20:28:44  Thomas_Woodburn
 * 	Created from Intel CDSA Version 2.0 Release 3.0.
 *
 * $EndLog$
 */
/*
 * @(#)$RCSfile: mrm_defs.h,v $ $Revision: 1.1.2.4 $ (DEC) $Date: 2000/08/31 18:09:07 $
 */
/*-----------------------------------------------------------------------
 * File: MRM_DEFS.H
 *
 * Copyright (c) 1998-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef MRM_DEFS_H
#define MRM_DEFS_H

#define MRM_VER_MAJOR 0
#define MRM_VER_MINOR 8
#ifdef COMPAQ_FIX
/* XXX Keep in sync with aalFuncTable[] in aaldefs.h. */
#define NUMCDSAFUNC 15
#else  /* COMPAQ_FIX */
#define NUMCDSAFUNC 181
#endif /* COMPAQ_FIX */

#define MRM_SCRATCH_DIR "mrm-scratch"
#ifdef WIN32
#define MRM_REQUEST_FILEPATH "mrm-scratch\\MRM_Req.esw"
#define MRM_REQUEST_CREDENTIAL_FILEPATH "mrm-scratch\\MRM_Cred.esw"
#define MRM_SIGNED_MANIFEST_FILEPATH "mrm-scratch\\MRM_Sign.esw"
#else
#define MRM_REQUEST_FILEPATH "mrm-scratch/MRM_Req.esw"
#define MRM_REQUEST_CREDENTIAL_FILEPATH "mrm-scratch/MRM_Cred.esw"
#define MRM_SIGNED_MANIFEST_FILEPATH "mrm-scratch/MRM_Sign.esw"
#endif
#define MRM_REQUEST_FILENAME "mrm-scratch/MRM_Req.esw"
#define MRM_REQUEST_CREDENTIAL_FILENAME "mrm-scratch/MRM_Cred.esw"
#define MRM_SIGNED_MANIFEST_FILENAME "mrm-scratch/MRM_Sign.esw"

#define MRM_APP_ID_ATTR "MRM-AppID"
#define MRM_CTXT_ID_ATTR "MRM-ContextID"
#define MRM_META_ATTR "MRM-Meta"
#define MRM_META_VALUE "DONOTSIGN"
#define MRM_REF_ONLY_ATTR "Integrity-VerifyData"
#define MRM_REF_ONLY_VALUE "reference"

#ifndef DllExport
#ifdef WIN32
#define DllExport __declspec( dllexport )
#else
#define DllExport
#endif
#endif /* !DllExport */

/* this is a hack to get around improper AlgID matching in ISL */
#define HASH_ALG "SHA-1"
#define SIG_ALG "DSA/SHA1"

#endif  /* MRM_DEFS_H */
