/*-----------------------------------------------------------------------
 * File: SCMEMTRACK.H
 *
 * Copyright (c) 1998-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef SC_MEMTRACK_H
#define SC_MEMTRACK_H


#ifdef __cplusplus
extern "C" {
#endif

#ifdef CSSM_MEMTRACK

#include <crtdbg.h>

/* The design of the following macros was motivated by the need for *
 * minimal code changes.  As a result, some of these macros appear  *
 * to violate principles of good programming.                       */

#define app_malloc(s, t) app_malloc((s), (t), __FILE__, __LINE__)
#define app_calloc(s, t, u) app_calloc((s), (t) ,(u), __FILE__, __LINE__)
#define app_realloc(s, t, u) app_realloc((s), (t), (u), __FILE__, __LINE__)
//#define app_free(s, t) app_free((s), (t))

/* Need this set of macros because flatfile makes it difficult for
   a simple solution.                                                  */

#define   malloc(s)         _malloc_dbg((s), _NORMAL_BLOCK, __FILE__, __LINE__)
#define   calloc(s, t)      _calloc_dbg((s), (t), _NORMAL_BLOCK, __FILE__, __LINE__)
#define   realloc(s, t)     _realloc_dbg((s), (t), _NORMAL_BLOCK, __FILE__, __LINE__)
#define   free(s)           _free_dbg((s), _NORMAL_BLOCK)

#define SC_MALLOC_WRAPPER(s, t, u) (s)((t), (u), __FILE__, __LINE__)
#define SC_CALLOC_WRAPPER(s, t, u, v) (s)((t) ,(u), (v), __FILE__, __LINE__)
#define SC_REALLOC_WRAPPER(s, t, u, v) (s)((t), (u), (v), __FILE__, __LINE__)
#define SC_FREE_WRAPPER(s, t, u) (s)((t), (u))

#else

#define SC_MALLOC_WRAPPER(s, t, u) (s)((t), (u))
#define SC_CALLOC_WRAPPER(s, t, u, v) (s)((t) ,(u), (v))
#define SC_REALLOC_WRAPPER(s, t, u, v) (s)((t), (u), (v))
#define SC_FREE_WRAPPER(s, t, u) (s)((t), (u))

#endif /* ifdef VMS SC_MEMTRACK / * not*/

#ifdef __cplusplus
}
#endif

#endif
