/*-----------------------------------------------------------------------
 * File: WF_TYPE.H
 *
 * Copyright (c) 1998-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef WF_TYPE_H
#define WF_TYPE_H

#include "isltype.h"
#include "isl_cssm.h"
#include "aal.h"
#ifdef WIN32
#define WFAPI __declspec(dllexport)
#else
#define WFAPI
#endif

#define WF_MAX_PATH _MAX_PATH
#define WF_MAX_STRING 2056

#ifndef uint8
    typedef unsigned char uint8;
#endif
#ifndef VMS   /* these are typedef'd by decc */
#ifndef uint16
    typedef unsigned short uint16;
#endif
#ifndef uint32
    typedef unsigned int uint32;
#endif
#endif /* VMS */
#ifndef sint32
	typedef int sint32;
#endif

typedef uint32 WF_HANDLE;
typedef enum {WF_OK=0, WF_FAIL} WF_RETURN;
typedef enum {WF_FALSE=0, WF_TRUE} WF_BOOL; 
typedef enum {MRM_ACCEPT=0, MRM_DENY, MRM_REJECT} MRM_SIGN_FLAG;
typedef char WF_STRING[WF_MAX_STRING];
typedef AAL_LIB_HANDLE WF_CSSM_HANDLE;
typedef AAL_FUNC_TABLE WF_CSSM_FUNC_TABLE;
typedef unsigned int WF_SIZE;
typedef ISL_CONST_DATA WF_CONST_DATA, *WF_CONST_DATA_PTR;
typedef ISL_ARCHIVE_CONFIG WF_ARCHIVE_CONFIG;
typedef ISL_ARCHIVE_CONTEXT WF_ARCHIVE_CONTEXT;
typedef ISL_SIGNATURE_CONFIG WF_SIGNATURE_CONFIG;
typedef ISL_SIGNATURE_CONTEXT WF_SIGNATURE_CONTEXT;
typedef ISL_DATA WF_DATA, *WF_DATA_PTR;
typedef CSSM_CERTGROUP WF_CERTGROUP, *WF_CERTGROUP_PTR;
typedef CSSM_DATA WF_CERT, *WF_CERT_PTR;
typedef CSSM_DL_DB_HANDLE WF_DB_HANDLE;
typedef ISL_CSSM_METHODS WF_CSSM_METHODS;

/* WF record types */
typedef uint8 WF_RECORD_TYPE;
#define WF_RECORD_ANY 0
#define WF_RECORD_MRM 1
#define WF_RECORD_KEY_GEN_REQ 1
#define WF_RECORD_CERT_REQ 2
#define WF_RECORD_POLICY_REQ 3

/* WF actions */
#define WF_ACTION_NONE   "WF_NONE"
#define WF_ACTION_SIGN   "WF_SIGN"
#define WF_ACTION_REVIEW "WF_REVIEW"


typedef struct wf_guid {
    uint32 Data1;
    uint16 Data2;
    uint16 Data3;
    uint8 Data4[8];
} WF_GUID, *WF_GUID_PTR;



#endif /* WF_TYPE_H */
